<?php
/*
Disclaimer and Copyright notice
PHPAdmin comes with no warranty and all the functionality contained within PHPAdmin is as is. The author reserves the right to distribute PHPAdmin in the versions and methods as he sees fit.

Acknowledgements Made by Using PHPAdmin
You acknowledge that PHPAdmin is protected by copyright and/or trademark including but not limited to PHP webpage source files, designs, titles, and words or phrases which may be registered in certain jurisdictions (collectively, the "Content"). You agree to comply with any additional copyright notices, information, or restrictions contained in any Content. Modification or alteration of the Content is forbidden without express written consent of the author. Users of PHPAdmin may use the Content only for their personal, noncommercial use. Users of PHPAdmin wanting to use the Content for commercial use must obtain prior express written permission of the author.

Contacting the Author
Should you have any questions regarding support, features, or the disclaimer, please contact the author via email at phpadmin@checkyour6.net.
*/


session_start();
$sc = new ServerCollection();



//MODIFY ONLY THESE THINGS START HERE
$sc->addServer( "Server", "127.0.0.1", 27015, "/home/hlds", "cstrike" );
$sc->setPublicUnban( TRUE );

$mySmartyRoot = "/home/webserverpath/www";

$phpadmin_mysqluser = "username";
$phpadmin_mysqlpassword = "password";
$phpadmin_mysqldatabase = "phpadmin";
$phpadmin_mysqlip = "mysqlserveripaddress";
//MODIFY ONLY THESE THINGS END HERE




//DO NOT MODIFY ANYTHING BELOW THIS LINE

$sqlgame = new Mysql();
$sqlgame->connect( $phpadmin_mysqluser, $phpadmin_mysqlpassword, $phpadmin_mysqlip, $phpadmin_mysqldatabase );

if( !class_exists( "Smarty" ) ) require( "smarty_library/Smarty.class.php" );
interface IObjectUI {
	public function getHTML();
	public function showHTML();
}
class ObjectUI extends Smarty {
	public function __construct() {
		global $mySmartyRoot;
		$this->template_dir = "{$mySmartyRoot}/smarty/templates";
		$this->config_dir = "{$mySmartyRoot}/smarty/config";
		$this->cache_dir = "{$mySmartyRoot}/smarty/cache";
		$this->compile_dir = "{$mySmartyRoot}/smarty/templates_c";
		$this->assign( "debug", FALSE );
	}
	public function getHtmlTpl( $tpl, $expire = NULL, $unique = NULL ) { return $this->fetch( $tpl, $url, NULL, FALSE ); }
	public function showHtmlTpl( $tpl, $expire = NULL, $unique = NULL ) {
		return $this->fetch( $tpl, $url, NULL, TRUE );
	}
	public function __destruct() { }
}
class AdminBanGagCommonUI extends ObjectUI implements IObjectUI {
	const UNKNOWN = 0;
	const BAN = 1;
	const GAG = 2;
	public function __construct( $q, $g, $s, $sc, $i, $t ) {
		parent::__construct();
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->sc = $sc;
		$this->ip = $i;
		$this->type = $t;
	}
	public function processCategory() {
		$this->sub = "root";
		if( isset( $_REQUEST["sub"] ) ) {
			if( $_REQUEST["sub"] != "root" ) { $this->sub = $_REQUEST["sub"]; }
		}
		$this->id = NULL;
		if( isset( $_REQUEST["id"] ) ) { $this->id = $_REQUEST["id"]; }
		$fr = new FormResponse( $this->sqlsite );
		if( !method_exists( $this, $this->sub ) ) {
			$this->sub = "error";
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "invalidsub", 1 ) );
			return;
		}
		if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", $this->sub ) != 0 ) {
			$this->sub = "error";
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "access", 2 ) );
			return;
		}
		call_user_func( array( &$this, $this->sub ) );
	}
	public function root() {
		$this->assign( "cat", $this->type == self::GAG ? "gag" : "ban" );
		$this->assign( "catreadable", $this->type == self::GAG ? "Gag" : "Ban" );
		$this->assign( "cated", $this->type == self::GAG ? "gagged" : "banned" );
	}
	public function add() {
		$offset = $this->id - ($this->id % 50);
		$bg = NULL;
		if( $this->type == self::GAG ) { $bg = new Gag( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		else { $bg = new Ban( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		$bangagArr = $bg->getCollection( NULL, 12, $offset, 50 );
		$total = $bg->getCollectionCount( NULL, 12 );
		$this->assign( "total", $total );
		$this->assign( "offset", $offset );
		$this->assign( "prevoffset", $offset - 50 );
		$this->assign( "nextoffset", $offset + 50 );
		$this->assign( "count", count($bangagArr) );
		$this->assign( "items", $bangagArr );
		$this->assign( "username", $this->session->getUsername() );
		$this->assign( "cat", $this->type == self::GAG ? "gag" : "ban" );
		$this->assign( "catreadable", $this->type == self::GAG ? "Gag" : "Ban" );
	}
	public function search() {
		$offset = $this->id - ($this->id % 50);
		$bg = NULL;
		if( $this->type == self::GAG ) { $bg = new Gag( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		else { $bg = new Ban( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		$banArr = NULL;
		$total = 0;
		$searchstr = "";
		if( isset($_REQUEST["search"]) ) {
			$searchstr = $_REQUEST["search"];
			$bangagArr = $bg->getCollection( $_REQUEST["search"], 4, $offset, 50 );
			$total = $bg->getCollectionCount( $_REQUEST["search"], 4 );
		}
		else if( isset($_POST["search"]) ) {
			$searchstr = $_POST["search"];
			$bangagArr = $bg->getCollection( $_POST["search"], 4, $offset, 50 );
			$total = $bg->getCollectionCount( $_POST["search"], 4 );
		}
		$this->assign( "total", $total );
		$this->assign( "offset", $offset );
		$this->assign( "prevoffset", $offset - 50 );
		$this->assign( "nextoffset", $offset + 50 );
		$this->assign( "count", count($bangagArr) );
		$this->assign( "items", $bangagArr );
		$this->assign( "username", $this->session->getUsername() );
		$this->assign( "search", $searchstr );
		$this->assign( "cat", $this->type == self::GAG ? "gag" : "ban" );
		$this->assign( "catreadable", $this->type == self::GAG ? "Gag" : "Ban" );
	}
	public function preremove() {
		$offset = $this->id - ($this->id % 50);
		$bg = NULL;
		if( $this->type == self::GAG ) { $bg = new Gag( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		else { $bg = new Ban( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		$bangagArr = $bg->getCollection( NULL, 4, $offset, 50 );
		$total = $bg->getCollectionCount( NULL, 4 );
		$this->assign( "total", $total );
		$this->assign( "offset", $offset );
		$this->assign( "prevoffset", $offset - 50 );
		$this->assign( "nextoffset", $offset + 50 );
		$this->assign( "count", count($bangagArr) );
		$this->assign( "items", $bangagArr );
		$this->assign( "username", $this->session->getUsername() );
		$this->assign( "cat", $this->type == self::GAG ? "gag" : "ban" );
		$this->assign( "catreadable", $this->type == self::GAG ? "Gag" : "Ban" );
	}
	public function remove() {
		$this->assign( "pid", $_REQUEST["id"] );
		$this->assign( "sid", $_REQUEST["sid"] );
		$this->assign( "username", $this->session->getUsername() );
		$this->assign( "cat", $this->type == self::GAG ? "gag" : "ban" );
		$this->assign( "catreadable", $this->type == self::GAG ? "Ungag" : "Unban" );
	}
	public function verify() {
		$bg = NULL;
		if( $this->type == self::GAG ) { $bg = new Gag( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		else { $bg = new Ban( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		$bangagArr = $bg->getPendingActions();
		$this->assign( "items", $bangagArr );
		$this->assign( "count", count($bangagArr) );
		$this->assign( "cat", $this->type == self::GAG ? "gag" : "ban" );
		$this->assign( "catreadable", $this->type == self::GAG ? "Gag" : "Ban" );
	}
	public function log() {
		$offset = $this->id - ($this->id % 50);
		$bg = NULL;
		if( $this->type == self::GAG ) { $bg = new Gag( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		else { $bg = new Ban( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		$logArr = $bg->getLogEntries( $offset, 50 );
		$total = $bg->getLogEntriesCount();
		$this->assign( "total", $total );
		$this->assign( "offset", $offset );
		$this->assign( "prevoffset", $offset - 50 );
		$this->assign( "nextoffset", $offset + 50 );
		$this->assign( "count", count($logArr) );
		$this->assign( "logs", $logArr );
		$this->assign( "cat", $this->type == self::GAG ? "gag" : "ban" );
		$this->assign( "catreadable", $this->type == self::GAG ? "Gag" : "Ban" );
	}
	public function form_setpermanent() {
		$bg = NULL;
		if( $this->type == self::GAG ) { $bg = new Gag( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		else { $bg = new Ban( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		$fres = $bg->setPermanent( $this->id );
		$this->formFunction( $fres );
	}
	public function form_add() {
		$bg = NULL;
		if( $this->type == self::GAG ) { $bg = new Gag( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		else { $bg = new Ban( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		$fres = $bg->addNewItem( $_POST["name"], $_POST["steamid"], $_POST["reason"] );
		$this->formFunction( $fres );
	}
	public function form_remove() {
		$bg = NULL;
		if( $this->type == self::GAG ) { $bg = new Gag( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		else { $bg = new Ban( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		$fres = $bg->deleteOldItem( $this->id, $_POST["reason"] );
		$this->formFunction( $fres );
	}
	public function form_verify() {
		$bg = NULL;
		if( $this->type == self::GAG ) { $bg = new Gag( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		else { $bg = new Ban( $this->sqlsite, $this->sqlgame, $this->session, $this->sc ); }
		$fres = $bg->verifyActionItems( $_POST["approve"] );
		$this->formFunction( $fres );
	}
	public function getHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->getHtmlTpl( "admin_bangag_root.tpl" );
			break;
			case "add":
			return $this->getHtmlTpl( "admin_bangag_add.tpl" );
			break;
			case "preremove":
			return $this->getHtmlTpl( "admin_bangag_preremove.tpl" );
			break;
			case "search":
			return $this->getHtmlTpl( "admin_bangag_search.tpl" );
			break;
			case "remove":
			return $this->getHtmlTpl( "admin_bangag_remove.tpl" );
			break;
			case "verify":
			return $this->getHtmlTpl( "admin_bangag_verify.tpl" );
			break;
			case "log":
			return $this->getHtmlTpl( "admin_bangag_logs.tpl" );
			break;
			default:
			return $this->getHtmlTpl( "admin_bangag.tpl" );
		}
	}
	public function showHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->showHtmlTpl( "admin_bangag_root.tpl" );
			break;
			case "add":
			return $this->showHtmlTpl( "admin_bangag_add.tpl" );
			break;
			case "preremove":
			return $this->showHtmlTpl( "admin_bangag_preremove.tpl" );
			break;
			case "search":
			return $this->showHtmlTpl( "admin_bangag_search.tpl" );
			break;
			case "remove":
			return $this->showHtmlTpl( "admin_bangag_remove.tpl" );
			break;
			case "verify":
			return $this->showHtmlTpl( "admin_bangag_verify.tpl" );
			break;
			case "log":
			return $this->showHtmlTpl( "admin_bangag_logs.tpl" );
			break;
			default:
			return $this->showHtmlTpl( "admin_bangag.tpl" );
		}
	}
	public function __destruct() { }
	private function clear() {
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
		$this->sc = NULL;
		$this->ip = NULL;
		$this->type = NULL;
		$this->id = NULL;
		$this->sub = NULL;
	}
	private function formFunction( $fres ) {
		$fr = new AdminFormResponseUI( $this->sqlsite );
		$fr->initialize( $fres );
		$this->assign( "bangag", $fr->getHTML() );
	}
	private $sqlsite;
	private $sqlgame;
	private $session;
	private $sc;
	private $ip;
	private $type;
	private $id;
	private $sub;
}
class Gag extends BanGagCommon {
	const UNKNOWN = 0;
	const BAN = 1;
	const GAG = 2;
	public function __construct( $q, $gq, $s, $sc ) {
		parent::__construct( $q, $gq, $s, $sc, self::GAG );
	}
}
class AdminFormResponseUI extends ObjectUI implements IObjectUI {
	const ERROR = 1;
	const THANKYOU = 2;
	public function __construct( $q ) {
		parent::__construct();
		$this->clear();
		$this->sql = $q;
	}
	public function initialize( $fr ) {
		$this->assign( "type", $fr->getType() == self::ERROR ? "Error" : "ThankYou" );
		$this->assign( "code", $fr->getCode() );
		$this->assign( "message", $fr->getMsg() );
	}
	public function getHTML() { return $this->getHtmlTpl( "admin_formresponse.tpl" ); }
	public function showHTML() { return $this->showHtmlTpl( "admin_formresponse.tpl" ); }
	public function __destruct() { }
	private function clear() { $this->sql = NULL; }
	private $sql;
}
class AdminCharacterUI extends ObjectUI implements IObjectUI {
	public function __construct( $q, $g, $s, $i ) {
		parent::__construct();
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->ip = $i;
	}
	public function processCategory() {
		$this->sub = "root";
		if( isset( $_REQUEST["sub"] ) ) {
			if( $_REQUEST["sub"] != "root" ) { $this->sub = $_REQUEST["sub"]; }
		}
		$this->id = NULL;
		if( isset( $_REQUEST["id"] ) ) { $this->id = $_REQUEST["id"]; }
		$fr = new FormResponse( $this->sqlsite );
		if( !method_exists( $this, $this->sub ) ) {
			$this->sub = "error";
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "invalidsub", 1 ) );
			return;
		}
		if( $this->session->canAccessWebPage( "config", $this->sub ) != 0 ) {
			$this->sub = "error";
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "access", 2 ) );
			return;
		}
		call_user_func( array( &$this, $this->sub ) );
	}
	public function root() { }
	public function add() { }
	public function preedit() {
		$c = new Character( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$count = $c->getCharacterCount();
		$animalArr = $c->getCharacters( NULL, NULL );
		$this->assign( "count", $count );
		$this->assign( "animals", $animalArr );
	}
	public function edit() {
		$c = new Character( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$animal = $c->getSingleCharacter( $_POST["id"] );
		$this->assign( "count", count($animal) );
		$this->assign( "animal", $animal );
	}
	public function delete() {
		$c = new Character( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$count = $c->getCharacterCount();
		$animalArr = $c->getCharacters( NULL, NULL );
		$this->assign( "count", $count );
		$this->assign( "animals", $animalArr );
	}
	public function form_add() {
		$c = new Character( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$fres = $c->addCharacter( $_POST["name"], $_POST["speak1"], $_POST["speak2"], $_POST["speak3"] );
		$this->formFunction( $fres );
	}
	public function form_edit() {
		$c = new Character( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$fres = $c->editCharacter( $this->id, $_POST["name"], $_POST["speak1"], $_POST["speak2"], $_POST["speak3"] );
		$this->formFunction( $fres );
	}
	public function form_delete() {
		$c = new Character( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$fres = $c->deleteCharacter( $this->id );
		$this->formFunction( $fres );
	}
	public function getHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->getHtmlTpl( "admin_character_root.tpl" );
			break;
			case "add":
			return $this->getHtmlTpl( "admin_character_add.tpl" );
			break;
			case "preedit":
			return $this->getHtmlTpl( "admin_character_preedit.tpl" );
			break;
			case "edit":
			return $this->getHtmlTpl( "admin_character_edit.tpl" );
			break;
			case "delete":
			return $this->getHtmlTpl( "admin_character_delete.tpl" );
			break;
			default:
			return $this->getHtmlTpl( "admin_character.tpl" );
		}
	}
	public function showHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->showHtmlTpl( "admin_character_root.tpl" );
			break;
			case "add":
			return $this->showHtmlTpl( "admin_character_add.tpl" );
			break;
			case "preedit":
			return $this->showHtmlTpl( "admin_character_preedit.tpl" );
			break;
			case "edit":
			return $this->showHtmlTpl( "admin_character_edit.tpl" );
			break;
			case "delete":
			return $this->showHtmlTpl( "admin_character_delete.tpl" );
			break;
			default:
			return $this->showHtmlTpl( "admin_character.tpl" );
		}
	}
	public function __destruct() { }
	private function clear() {
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
		$this->ip = NULL;
		$this->id = NULL;
		$this->sub = NULL;
	}
	private function formFunction( $fres ) {
		$fr = new AdminFormResponseUI( $this->sqlsite );
		$fr->initialize( $fres );
		$this->assign( "character", $fr->getHTML() );
	}
	private $sqlsite;
	private $sqlgame;
	private $session;
	private $ip;
	private $id;
	private $sub;
}
class Logs {
	const LOG_BAN = 1;
	const LOG_GAG = 2;
	const LOG_KICK = 3;
	const VOTE_BAN = 1;
	const VOTE_GAG = 2;
	const VOTE_KICK = 3;
	const VOTE_SLAP = 4;
	public function __construct( $q, $g, $s, $i ) {
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->ip = $i;
	}
	public function getReportCount( $status ) {
		if( !$this->session->isAuthed() ) { return -1; }
		if( $this->session->canAccessWebPage( "log", "pending" ) != 0 ) { return -2; }
		$status = isset( $status ) ? trim( htmlspecialchars( $status ) ) : NULL;
		if( is_null($status) ) { return -3; }
		$status = $this->sqlsite->getEscapeString( $status );
		$selectQuery = "SELECT COUNT(id) FROM report WHERE status = {$status}";
		$cnt = $this->sqlgame->count( $selectQuery );
		return $cnt;
	}
	public function getReport( $status, $offset, $limit ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( "log", "pending" ) != 0 ) { return NULL; }
		$status = isset( $status ) ? trim( htmlspecialchars( $status ) ) : NULL;
		$offset = isset( $offset ) ? trim( $offset ) : NULL;
		$limit = isset( $limit ) ? trim( htmlspecialchars( $limit ) ) : NULL;
		$errorcode = 0;
		if( is_null($status) || is_null($offset) || is_null($limit) ) { return NULL; }
		$status = $this->sqlsite->getEscapeString( $status );
		$offset = $this->sqlsite->getEscapeString( $offset );
		$limit = $this->sqlsite->getEscapeString( $limit );
		$myarr = array();
		$selectQuery = "SELECT id, reporterid, reporteeid, reporter, reportee, timestamp, status, action FROM report WHERE status = {$status} ORDER BY id DESC LIMIT {$offset}, {$limit}";
		try {
			$res = $this->sqlgame->query( $selectQuery );
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$steamid = $res->getValueAt( 1 );
				$reportid = $res->getValueAt( 2 );
				$reporter = $res->getValueAt( 3 );
				$reportee = $res->getValueAt( 4 );
				$timestamp = $res->getValueAt( 5 );
				$status = $res->getValueAt( 6 );
				$action = $res->getValueAt( 7 );
				$item = array();
				$item["id"] = $id;
				$item["steamid"] = $steamid;
				$item["reportid"] = $reportid;
				$item["reporter"] = $reporter;
				$item["reportee"] = $reportee;
				$item["timestamp"] = date( "D M j G:i:s Y", $timestamp );
				$item["status"] = $status;
				$item["action"] = $action;
				$myarr[$cnt] = $item;
				$cnt++;
			}
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return $e->getCode(); }
		return $myarr;
	}
	public function getLogEntriesCount() {
		if( !$this->session->isAuthed() ) { return -1; }
		if( $this->session->canAccessWebPage( "log", "kick" ) != 0 ) { return -1; }
		$logtype = self::LOG_KICK;
		$selectQuery = "SELECT COUNT(id) FROM logged WHERE type = {$logtype}";
		$cnt = $this->sqlgame->count($selectQuery);
		return $cnt;
	}
	public function getLogEntries( $offset, $limit ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( "log", "kick" ) != 0 ) { return NULL; }
		$offset = isset( $offset ) ? trim( htmlspecialchars( $offset ) ) : NULL;
		$limit = isset( $limit ) ? trim( htmlspecialchars( $limit ) ) : NULL;
		if( is_null($offset) || is_null($limit) ) { return NULL; }
		$logtype = self::LOG_KICK;
		$offset = $this->sqlsite->getEscapeString($offset);
		$limit = $this->sqlsite->getEscapeString($limit);
		$queryLog = "SELECT id, timestamp, actionid, actionname, receiveid, receivename, action FROM logged WHERE type = {$logtype} ORDER BY timestamp DESC LIMIT {$offset}, {$limit}";
		$resArray = array();
		try {
			$res = $this->sqlgame->query($queryLog);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$timestamp = $res->getValueAt( 1 );
				$adminid = $res->getValueAt( 2 );
				$adminname = $res->getValueAt( 3 );
				$receiveid = $res->getValueAt( 4 );
				$receivename = $res->getValueAt( 5 );
				$action = $res->getValueAt( 6 );
				$item = array();
				$item["id"] = $id;
				$item["name"] = $receivename;
				$item["steamid"] = $receiveid;
				$item["admin"] = $adminname;
				$item["timestamp"] = date( "D M j G:i:s Y", $timestamp );
				$item["action"] = $action;
				$resArray[$cnt] = $item;
				$cnt++;
			}
		}
		catch( MysqlException $e ) { return NULL; }
		return $resArray;
	}
	public function getVoteLogsCount() {
		if( !$this->session->isAuthed() ) { return -1; }
		if( $this->session->canAccessWebPage( "log", "vote" ) != 0 ) { return -1; }
		$selectVotes = "SELECT COUNT(id) FROM votelog";
		$cnt = $this->sqlgame->count($selectVotes);
		return $cnt;
	}
	public function getVoteLogs( $offset, $limit ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( "log", "vote" ) != 0 ) { return NULL; }
		$offset = isset( $offset ) ? trim( htmlspecialchars( $offset ) ) : NULL;
		$limit = isset( $limit ) ? trim( htmlspecialchars( $limit ) ) : NULL;
		if( is_null($offset) || is_null($limit) ) { return NULL; }
		$offset = $this->sqlsite->getEscapeString($offset);
		$limit = $this->sqlsite->getEscapeString($limit);
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$myarray = array();
		$selectVotes = "SELECT id, action, timestamp, actionid, actionname, receiveid, receivename, yay_steamid, nay_steamid, yay_name, nay_name, reason FROM votelog ORDER BY id DESC LIMIT ${offset}, {$limit}";
		try {
			$res = $this->sqlgame->query($selectVotes);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$action = $res->getValueAt( 1 );
				$timestamp = $res->getValueAt( 2 );
				$starterid = $res->getValueAt( 3 );
				$startername = $res->getValueAt( 4 );
				$receiveid = $res->getValueAt( 5 );
				$receivename = $res->getValueAt( 6 );
				$yay_steamid = $res->getValueAt( 7 );
				$nay_steamid = $res->getValueAt( 8 );
				$yay_name = $res->getValueAt( 9 );
				$nay_name = $res->getValueAt( 10 );
				$reason = $res->getValueAt( 11 );
				$yaySteamidArr = explode( "\n", $yay_steamid );
				$naySteamidArr = explode( "\n", $nay_steamid );
				$yayNameArr = explode( "\n", $yay_name );
				$nayNameArr = explode( "\n", $nay_name );
				$actionstr = "Unknown";
				switch( $action ) {
	 				case self::VOTE_BAN:
					$actionstr = "Ban";
					break;
					case self::VOTE_KICK:
					$actionstr = "Kick";
					break;
					case self::VOTE_GAG:
					$actionstr = "Gag";
					break;
					case self::VOTE_SLAP:
					$actionstr = "Slap";
					break;
					default:
					$actionstr = "Unknown";		
				}
				$item = array();
				$item["id"] = $id;
				$item["action"] = $actionstr;
				$item["timestamp"] = date( "D M j G:i:s Y", $timestamp );
				$item["starterid"] = $starterid;
				$item["startername"] = $startername;
				$item["receiveid"] = $receiveid;
				$item["receivename"] = $receivename;
				$item["yaysteamid"] = $yaySteamidArr;
				$item["naysteamid"] = $naySteamidArr;
				$item["yayname"] = $yayNameArr;
				$item["nayname"] = $nayNameArr;
				$item["reason"] = $reason;
				$myarray[$cnt] = $item;
				$cnt++;
			}
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return NULL; }
		return $myarray;
	}
	public function handleReport( $id ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "log", "form_handled" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		if( is_null($id) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$id = $this->sqlsite->getEscapeString( $id );
		$updateQuery = "UPDATE report SET status = 1 WHERE id = {$id}";
		try {
			$res = $this->sqlgame->query( $updateQuery );
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "handled", 0 );
	}
	public function __destruct() { }
	private function clear() {
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
		$this->ip = NULL;
	}
	private $sqlsite;
	private $sqlgame;
	private $session;	
	private $ip;
}
class MysqlResult {
	public function __construct( $r ) {
		$this->clear();
		$this->result = $r;
	}
	public function getNumRows() { return mysql_num_rows( $this->result ); }
	public function getNextRow() {
		$this->row = mysql_fetch_row( $this->result );
		return $this->row != NULL;
	}
	public function getValueAt( $index ) {
		if( $index < 0 || $index >= mysql_num_fields( $this->result ) ) { throw new MysqlException( "Invalid Index" ); }
		return $this->row[$index];
	}
	public function getResult() { return $this->result; }
	public function __destruct() { }
	private function clear() {
		$this->result = 0;
		$this->row = 0;
	}
	private $result;
	private $row;
}
class CatEveryone {
	public function __construct( $q, $s ) {
		$this->clean();
		$this->sql = $q;
		$this->session = $s;
	}
	public function loginForm( $username, $password, $ip ) {
		$username = isset( $username ) ? trim( htmlspecialchars( $username ) ) : NULL;
		$password = isset( $password ) ? trim( htmlspecialchars( $password ) ) : NULL;
		$ip = isset( $ip ) ? trim( htmlspecialchars( $ip ) ) : NULL;
		$fr = new FormResponse( $this->sql );
		if( is_null($username) || is_null($password) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 1 ); }
		if( $this->session->login( $username, $password ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "login", 2 ); }
		return $fr->getResponse( FormResponse::THANKYOU, "login", 0 );
	}
	public function changeMyLostPassword( $passwordFirst, $passwordSecond ) {
		$passwordFirst = isset( $passwordFirst ) ? trim( htmlspecialchars( $passwordFirst ) ) : NULL;
		$passwordSecond = isset( $passwordSecond ) ? trim( htmlspecialchars( $passwordSecond ) ) : NULL;
		$fr = new FormResponse( $this->sql );
		if( is_null($passwordFirst) || is_null($passwordSecond) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 1 ); }
		else if( $passwordFirst != $passwordSecond ) { return $fr->getResponse( FormResponse::ERROR, "passmatch", 2 ); }
		$username = $this->sql->getEscapeString( $this->session->getUsername() );
		$userid = $this->sql->getEscapeString( $this->session->getUserId() );
		$passwordFirst = $this->sql->getEscapeString( $passwordFirst );
		$passwordSecond = $this->sql->getEscapeString( $passwordSecond );
		$md5Password = md5($passwordFirst);
		$updateUserPassword = "UPDATE staff SET password = '{$md5Password}' WHERE playername = '{$username}' AND id = {$userid}";
		try {
			$res = $this->sql->query($updateUserPassword);
			$this->sql->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "passwordreset", 0 );
	}
	public function logoutUser() {
		$this->session->logout();
		$fr = new FormResponse( $this->sql );
		return $fr->getResponse( FormResponse::THANKYOU, "logout", 0 );
	}
	public function deletePublicOldItem( $steamid, $reason ) {
		$bg = new Ban( $this->sql, $this->sql, $this->session, NULL );
		return $bg->deletePublicOldItem( $steamid, $reason );
	}
	public function __destruct() { }
	private function clean() {
		$this->sql = NULL;
		$this->session = NULL;
	}
	private $sql;
	private $session;
}
class AdminConfigUI extends ObjectUI implements IObjectUI {
	public function __construct( $q, $g, $s, $sc, $i ) {
		parent::__construct();
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->sc = $sc;
		$this->ip = $i;
	}
	public function processCategory() {
		$this->sub = "root";
		if( isset( $_REQUEST["sub"] ) ) {
			if( $_REQUEST["sub"] != "root" ) { $this->sub = $_REQUEST["sub"]; }
		}
		$this->id = NULL;
		if( isset( $_REQUEST["id"] ) ) { $this->id = $_REQUEST["id"]; }
		$fr = new FormResponse( $this->sqlsite );
		if( !method_exists( $this, $this->sub ) ) {
			$this->sub = "error";
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "invalidsub", 1 ) );
			return;
		}
		if( $this->session->canAccessWebPage( "config", $this->sub ) != 0 ) {
			$this->sub = "error";
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "access", 2 ) );
			return;
		}
		call_user_func( array( &$this, $this->sub ) );
	}
	public function root() { }
	public function addad() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$cfgArr = $s->getConfig( NULL, TRUE );
		$this->assign( "servercount", count($cfgArr) );
		$this->assign( "servers", $cfgArr );
	}
	public function deletead() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$count = $s->getAdCount();
		$adsArr = $s->getAds( NULL, NULL, NULL );
		$servers = $this->sc->toArray();
		$this->assign( "servercount", count($servers) );
		$this->assign( "servers", $servers );
		$this->assign( "adcount", $count );
		$this->assign( "ads", $adsArr );
	}
	public function add() {	}
	public function preedit() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$cfgArr = $s->getConfig( NULL, TRUE );
		$this->assign( "count", count($cfgArr) );
		$this->assign( "config", $cfgArr );
	}
	public function edit() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$cfgArr = $s->getConfig( $_POST["id"], TRUE );
		$servers = $this->sc->toArray();
		$this->assign( "count", count($cfgArr) );
		$this->assign( "config", $cfgArr[0] );
		$this->assign( "servers", $servers );
	}
	public function copy() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$cfgArr = $s->getConfig( NULL, FALSE );
		$this->assign( "count", count($cfgArr) );
		$this->assign( "config", $cfgArr );
	}
	public function delete() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$cfgArr = $s->getConfig( NULL, TRUE );
		$this->assign( "count", count($cfgArr) );
		$this->assign( "config", $cfgArr );
	}
	public function precycle() {
		$this->assign( "count", count($this->sc->toActiveArray()) );
		$this->assign( "servers", $this->sc->toActiveArray() );
	}
	public function mapcycle() {
		$myid = !is_null($this->id) ? $this->id : 0;
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$curlist = $s->getMapcycle( $myid );
		$availablelist = $s->getMapsAvailable( $myid );
		$mapcycle = implode( "", $curlist );
		$this->assign( "id", $myid );
		$this->assign( "mapcycle", $mapcycle );
		$this->assign( "maps", $availablelist );
	}
	public function upload() {
		$this->assign( "count", count($this->sc->toActiveArray()) );
		$this->assign( "servers", $this->sc->toActiveArray() );
	}
	public function form_add() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $s->addNewCfg( $_POST["name"], $_POST["config"] );
		$this->formFunction( $fres );
	}
	public function form_edit() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $s->editCfg( $this->id, $_POST["config"], $_POST["activated"] );
		$this->formFunction( $fres );
	}
	public function form_copy() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $s->copyCfg( $this->id, $_POST["name"] );
		$this->formFunction( $fres );
	}
	public function form_delete() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $s->deleteCfg( $this->id );
		$this->formFunction( $fres );
	}
	public function form_mapcycle() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $s->updateMapcycle( $this->id, $_POST["mapcycle"] );
		$this->formFunction( $fres );
	}
	public function form_upload() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $s->uploadMap( $_POST["id"], "bsp", "txt" );
		$this->formFunction( $fres );
	}
	public function form_addad() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $s->addAd( $_POST["serverid"], $_POST["advertisement"] );
		$this->formFunction( $fres );
	}
	public function form_deletead() {
		$s = new ServerConfig( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $s->deleteAd( $_POST["serverid"] );
		$this->formFunction( $fres );
	}
	public function getHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->getHtmlTpl( "admin_config_root.tpl" );
			break;
			case "addad":
			return $this->getHtmlTpl( "admin_config_addad.tpl" );
			break;
			case "deletead":
			return $this->getHtmlTpl( "admin_config_deletead.tpl" );
			break;
			case "add":
			return $this->getHtmlTpl( "admin_config_add.tpl" );
			break;
			case "preedit":
			return $this->getHtmlTpl( "admin_config_preedit.tpl" );
			break;
			case "edit":
			return $this->getHtmlTpl( "admin_config_edit.tpl" );
			break;
			case "copy":
			return $this->getHtmlTpl( "admin_config_copy.tpl" );
			break;
			case "delete":
			return $this->getHtmlTpl( "admin_config_delete.tpl" );
			break;
			case "precycle":
			return $this->getHtmlTpl( "admin_config_precycle.tpl" );
			break;
			case "mapcycle":
			return $this->getHtmlTpl( "admin_config_mapcycle.tpl" );
			break;
			case "upload":
			return $this->getHtmlTpl( "admin_config_upload.tpl" );
			break;
			default:
			return $this->getHtmlTpl( "admin_config.tpl" );
		}
	}
	public function showHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->showHtmlTpl( "admin_config_root.tpl" );
			break;
			case "addad":
			return $this->showHtmlTpl( "admin_config_addad.tpl" );
			break;
			case "deletead":
			return $this->showHtmlTpl( "admin_config_deletead.tpl" );
			break;
			case "add":
			return $this->showHtmlTpl( "admin_config_add.tpl" );
			break;
			case "preedit":
			return $this->showHtmlTpl( "admin_config_preedit.tpl" );
			break;
			case "edit":
			return $this->showHtmlTpl( "admin_config_edit.tpl" );
			break;
			case "copy":
			return $this->showHtmlTpl( "admin_config_copy.tpl" );
			break;
			case "delete":
			return $this->showHtmlTpl( "admin_config_delete.tpl" );
			break;
			case "precycle":
			return $this->showHtmlTpl( "admin_config_precycle.tpl" );
			break;
			case "mapcycle":
			return $this->showHtmlTpl( "admin_config_mapcycle.tpl" );
			break;
			case "upload":
			return $this->showHtmlTpl( "admin_config_upload.tpl" );
			break;
			default:
			return $this->showHtmlTpl( "admin_config.tpl" );
		}
	}
	public function __destruct() { }
	private function clear() {
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
		$this->sc = NULL;
		$this->ip = NULL;
		$this->id = NULL;
		$this->sub = NULL;
	}
	private function formFunction( $fres ) {
		$fr = new AdminFormResponseUI( $this->sqlsite );
		$fr->initialize( $fres );
		$this->assign( "config", $fr->getHTML() );
	}
	private $sqlsite;
	private $sqlgame;
	private $session;
	private $sc;
	private $ip;
	private $id;
	private $sub;
}
class AdminBanUI extends AdminBanGagCommonUI {
	const UNKNOWN = 0;
	const BAN = 1;
	const GAG = 2;
	public function __construct( $q, $g, $s, $sc, $i ) {
		parent::__construct( $q, $g, $s, $sc, $i, self::BAN );
	}
	public function __destruct() { }
}
class Character {
	const LOG_BAN = 1;
	const LOG_GAG = 2;
	const LOG_KICK = 3;
	const VOTE_BAN = 1;
	const VOTE_GAG = 2;
	const VOTE_KICK = 3;
	const VOTE_SLAP = 4;
	public function __construct( $q, $g, $s, $i ) {
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->ip = $i;
	}
	public function getCharacterCount() {
		if( !$this->session->isAuthed() ) { return 0; }
		if( $this->session->canAccessWebPage( "character", "root" ) != 0 ) { return 0; }
		$selectQuery = "SELECT COUNT(id) FROM animals";
		$cnt = $this->sqlgame->count($selectQuery);
		return $cnt;
	}
	public function getSingleCharacter( $id ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( "character", "root" ) != 0 ) { return NULL; }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		if( is_null($id) ) { return NULL; }
		$id = $this->sqlsite->getEscapeString($id);
		$selectQuery = "SELECT id, animal, count, say1, say2, say3 FROM animals WHERE id = {$id}";
		try {
			$res = $this->sqlgame->query($selectQuery);
			if( !$res->getNextRow() ) {
				$this->sqlsite->cleanUpResult( $res );
				return NULL;
			}
			$id = $res->getValueAt( 0 );
			$animal = $res->getValueAt( 1 );
			$count = $res->getValueAt( 2 );
			$say1 = $res->getValueAt( 3 );
			$say2 = $res->getValueAt( 4 );
			$say3 = $res->getValueAt( 5 );
	 		$item = array();
			$item["id"] = $id;
			$item["animal"] = $animal;
			$item["count"] = $count;
			$item["say1"] = $say1;
			$item["say2"] = $say2;
			$item["say3"] = $say3;
			$this->sqlsite->cleanUpResult( $res );
			return $item;
		}
		catch( MysqlException $e ) {
			$this->sqlsite->cleanUpResult( $res );
			return NULL;
		}
		return NULL;
	}
	public function getCharacters( $offset, $limit ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( "character", "root" ) != 0 ) { return NULL; }
		$offset = isset( $offset ) ? trim( htmlspecialchars( $offset ) ) : NULL;
		$limit = isset( $limit ) ? trim( htmlspecialchars( $limit ) ) : NULL;
		$selectQuery = "SELECT id, animal, count, say1, say2, say3 FROM animals ORDER BY id ASC";
		if( !is_null($offset) && !is_null($limit) ) {
			$offset = $this->sqlsite->getEscapeString($offset);
			$limit = $this->sqlsite->getEscapeString($limit);
			$selectQuery .= " LIMIT {$offset}, {$limit}";
		}
		$resArray = array();
		try {
			$res = $this->sqlgame->query($selectQuery);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$animal = $res->getValueAt( 1 );
				$count = $res->getValueAt( 2 );
				$say1 = $res->getValueAt( 3 );
				$say2 = $res->getValueAt( 4 );
				$say3 = $res->getValueAt( 5 );
				$item = array();
				$item["id"] = $id;
				$item["animal"] = $animal;
				$item["count"] = $count;
				$item["say1"] = $say1;
				$item["say2"] = $say2;
				$item["say3"] = $say3;
				$resArray[$cnt] = $item;
				$cnt++;
			}
			$this->sqlsite->cleanUpResult( $res );
		}
		catch( MysqlException $e ) {
			$this->sqlsite->cleanUpResult( $res );
			return NULL;
		}
		return $resArray;
	}
	public function addCharacter( $name, $speak1, $speak2, $speak3 ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "character", "root" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$name = isset( $name ) ? trim( htmlspecialchars( $name ) ) : NULL;
		$speak1 = isset( $speak1 ) ? trim( htmlspecialchars( $speak1 ) ) : NULL;
		$speak2 = isset( $speak2 ) ? trim( htmlspecialchars( $speak2 ) ) : NULL;
		$speak3 = isset( $speak3 ) ? trim( htmlspecialchars( $speak3 ) ) : NULL;
		if( is_null($name) || is_null($speak1) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$cnt = 1;
		$name = $this->sqlsite->getEscapeString($name);
		$speak1 = $this->sqlsite->getEscapeString($speak1);
		if( !is_null($speak2) ) {
			$cnt++;
			$speak2 = $this->sqlsite->getEscapeString($speak2);
		}
		else { $speak2 = "NONE"; }
		if( !is_null($speak3) ) {
			$cnt++;
			$speak3 = $this->sqlsite->getEscapeString($speak3);
		}
		else { $speak3 = "NONE"; }
		$selectQuery = "INSERT INTO animals (id, animal, count, say1, say2, say3) VALUES ( NULL, '{$name}', {$cnt}, '{$speak1}', '{$speak2}', '{$speak3}' )";
		try {
			$res = $this->sqlgame->query($selectQuery);
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) {
			$this->sqlgame->cleanUpResult( $res );
			return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() );
		}
		return $fr->getResponse( FormResponse::THANKYOU, "addcharacter", 0 );
	}
	public function editCharacter( $id, $name, $speak1, $speak2, $speak3 ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "character", "root" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		$name = isset( $name ) ? trim( htmlspecialchars( $name ) ) : NULL;
		$speak1 = isset( $speak1 ) ? trim( htmlspecialchars( $speak1 ) ) : NULL;
		$speak2 = isset( $speak2 ) ? trim( htmlspecialchars( $speak2 ) ) : NULL;
		$speak3 = isset( $speak3 ) ? trim( htmlspecialchars( $speak3 ) ) : NULL;
		if( is_null($id) || is_null($name) || is_null($speak1) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$cnt = 1;
		$id = $this->sqlsite->getEscapeString($id);
		$name = $this->sqlsite->getEscapeString($name);
		$speak1 = $this->sqlsite->getEscapeString($speak1);
		if( !is_null($speak2) ) {
			$cnt++;
			$speak2 = $this->sqlsite->getEscapeString($speak2);
		}
		else { $speak2 = "NONE"; }
		if( !is_null($speak3) ) {
			$cnt++;
			$speak3 = $this->sqlsite->getEscapeString($speak3);
		}
		else { $speak3 = "NONE"; }
		$updateQuery = "UPDATE animals SET animal = '{$name}', count = {$cnt}, say1 = '{$speak1}', say2 = '{$speak2}', say3 = '{$speak3}' WHERE id = {$id}";
		try {
			$res = $this->sqlgame->query($updateQuery);
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) {
			$this->sqlgame->cleanUpResult( $res );
			return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() );
		}
		return $fr->getResponse( FormResponse::THANKYOU, "editcharacter", 0 );
	}
	public function deleteCharacter( $id ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "character", "root" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		if( is_null($id ) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$id = $this->sqlsite->getEscapeString($id);
		$updateQuery = "DELETE FROM animals WHERE id = {$id}";
		try {
			$res = $this->sqlgame->query($updateQuery);
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) {
			$this->sqlgame->cleanUpResult( $res );
			return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() );
		}
		return $fr->getResponse( FormResponse::THANKYOU, "deletecharacter", 0 );
	}
	public function __destruct() { }
	private function clear() {
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
		$this->ip = NULL;
	}
	private $sqlsite;
	private $sqlgame;
	private $session;	
	private $ip;
}
class Mysql {
	public function __construct() {
		$this->clear();
	}
	public function connect( $u, $p, $h, $d ) {
		$this->dbuser = $u;
		$this->dbpass = $p;
		$this->dbhost = $h;
		$this->db = $d;
		$this->link_id = mysql_connect( $this->dbhost, $this->dbuser, $this->dbpass );
		if( !$this->link_id ) { throw new MysqlException( mysql_error() ); }
		if( !mysql_select_db( $this->db, $this->link_id ) ) { throw new MysqlException( mysql_error() ); }
	}
	public function changeDb( $d ) {
		$this->db = $d;
		if( !mysql_select_db( $this->db, $this->link_id ) ) { throw new MysqlException( mysql_error() ); }
	}
	public function query( $action ) {
		$myresult = mysql_query( $action, $this->link_id );
		if( !$myresult ) { throw new MysqlException( $action . " / " . mysql_error(), mysql_errno( $this->link_id ) ); }
		$res = new MysqlResult( $myresult );
		return $res;
	}
	public function count( $action ) {
		$cnt = -1;
		try {
			$res = $this->query( $action );
			if( !$res->getNextRow() ) {
				$this->cleanUpResult( $res );
				return $cnt;
			}
			$cnt = $res->getValueAt( 0 );
			$this->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return $cnt; }
		return $cnt;
	}
	public function getEscapeString( $string ) {
		if( is_null( $string ) ) { return NULL; }
		$mynewstring = mysql_real_escape_string( $string, $this->link_id );
		return $mynewstring;
	}
	public function getLastInsertId() { return mysql_insert_id( $this->link_id ); }
	public function getAffectedRows() { return mysql_affected_rows( $this->link_id ); }
	public function cleanUpResult( $res ) {
		if( !is_null($res) && $res->getResult() != NULL && !is_bool($res->getResult()) )
			mysql_free_result( $res->getResult() );
	}
	public function close() {
		if( $this->link_id != NULL ) { mysql_close( $this->link_id ); }
		$this->link_id = NULL;
	}
	public function __destruct() { $this->close(); }
	private function clear() {
		$this->dbhost = "";
		$this->dbuser = "";
		$this->dbpass = "";
		$this->db = "";
		$this->link_id = 0;
	}
	private $dbhost;
	private $dbuser;
	private $dbpass;
	private $db;
	private $link_id;
}
class ServerCollection {
	public function __construct() { $this->clean(); }
	public function addServer( $n, $i, $p, $h, $m ) {
		$pos = $this->getServerCount();
		$this->name[$pos] = $n;
		$this->ip[$pos] = $i;
		$this->port[$pos] = $p;
		$this->hldspath[$pos] = $h;
		$this->mod[$pos] = $m;
	}
	public function getServerCount() {
		if( $this->name == NULL ) { return 0; }
		return count( $this->name );
	}
	public function getNameAt( $id ) { return $this->name[$id]; }
	public function getIPAt( $id ) { return $this->ip[$id]; }
	public function getPortAt( $id ) { return $this->port[$id]; }
	public function getModAt( $id ) { return $this->mod[$id]; }
	public function getHLDSPathAt( $id ) { return $this->hldspath[$id]; }
	public function getPublicUnban() { return $this->pubunban; }
	public function toArray() {
		$mytmp = array();
		for( $i = 0; $i < count( $this->name ); $i++ ) {
			$tmp = array();
			$tmp["id"] = $i;
			$tmp["name"] = $this->name[$i];
			$tmp["ip"] = $this->ip[$i];
			$tmp["port"] = $this->port[$i];
			$tmp["value"] = pow( 2, $i );
			$tmp["hldspath"] = $this->hldspath[$i];
			$tmp["mod"] = $this->mod[$i];
			$mytmp[$i] = $tmp;
		}
		return $mytmp;
	}
	public function toActiveArray() {
		$mytmp = array();
		for( $i = 0; $i < count( $this->name ); $i++ ) {
			if( $this->hldspath[$i] == NULL ) { continue; }
			$tmp = array();
			$tmp["id"] = $i;
			$tmp["name"] = $this->name[$i];
			$tmp["ip"] = $this->ip[$i];
			$tmp["port"] = $this->port[$i];
			$tmp["value"] = pow( 2, $i );
			$tmp["hldspath"] = $this->hldspath[$i];
			$tmp["mod"] = $this->mod[$i];
			$mytmp[$i] = $tmp;
		}
		return $mytmp;
	}
	public function setPublicUnban( $v ) {
		if( $v == TRUE ) {
			$this->pubunban = TRUE;
			return;
		}
		$this->pubunban = FALSE;
	}
	public function __destruct() { }
	private function clean() {
		$this->name = array();
		$this->ip = array();
		$this->port = array();
		$this->hldspath = array();
		$this->mod = array();
		$this->pubunban = FALSE;
	}
	private $name;
	private $ip;
	private $port;
	private $hldspath;
	private $mod;
	private $pubunban;
}
class FormResult {
	const ERROR = 1;
	const THANKYOU = 2;
	public function __construct( $t, $m, $c ) {
		$this->type = $t;
		$this->code = $c;
		$this->msg = $m;
	}
	public function getType() { return $this->type; }
	public function getCode() { return $this->code; }
	public function getMsg() { return $this->msg; }
	public function __destruct() { }
	private $type;
	private $code;
	private $msg;
}
class Accounts {
	const ACTIVE = 1;
	const DELETED = 2;
	const MODERATED = 4;
	public function __construct( $q, $g, $s, $sc ) {
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->sc = $sc;
	}
	public function addServerUser( $username, $password, $steamids, $groups, $irc ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "accts", "form_addserveruser" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$username = isset($username) ? trim( htmlspecialchars( $username ) ) : NULL;
		$password = isset($password) ? trim( htmlspecialchars( $password ) ) : NULL;
		$steamids = isset($steamids) ? trim( $steamids ) : NULL;
		$steamids .= "\r\n";
		$groups = isset($groups) ? $groups : NULL;
		$irc = isset($irc) ? trim( htmlspecialchars( $irc ) ) : NULL;
		if( is_null($username) || is_null($password) || is_null($steamids) || is_null($groups) || is_null($irc) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		else if( preg_match( "/^((STEAM_0:)[01]{1}[:]{1}[0-9]+\r\n)+$/", $steamids ) == 0 ) { return $fr->getResponse( FormResponse::ERROR, "steamid", 2 ); }
		$steamids = trim($steamids);
		$sids = explode( "\r\n", $steamids );
		$username = $this->sqlsite->getEscapeString( $username );
		$password = md5( $this->sqlsite->getEscapeString( $password ) );
		$irc = $this->sqlsite->getEscapeString( $irc );
		try {
			$insertStaff = "INSERT INTO staff (id, playername, password, ircauth) VALUES ( NULL, '{$username}', '{$password}', '${irc}' )";
			$res1 = $this->sqlgame->query( $insertStaff );
			$affrows1 = $this->sqlgame->getAffectedRows();
			$staffid = $this->sqlgame->getLastInsertId();
			$this->sqlgame->cleanUpResult($res1);
			if( $affrows1 == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 5 ); }
			for( $i = 0; $i < $this->sc->getServerCount(); $i++ ) {
				$groupvalue = $this->sqlsite->getEscapeString( $groups[$i] );
				$servervalue = pow( 2, $i );
				$insertServers = "INSERT INTO servers (id, servervalue, staffid, usergroupid) VALUES ( NULL, {$servervalue}, {$staffid}, {$groupvalue} )";
				$res2 = $this->sqlgame->query( $insertServers );
				$affrows2 = $this->sqlgame->getAffectedRows();
				$this->sqlgame->cleanUpResult($res2);
				if( $affrows2 == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 5 ); }
			}
			for( $i = 0; $i < count($sids); $i++ ) {
				$sid = $this->sqlsite->getEscapeString( $sids[$i] );
				$insertSteamids = "INSERT INTO steamids (id, staffid, steamid) VALUES ( NULL, {$staffid}, '{$sid}' )";
				$res3 = $this->sqlgame->query( $insertSteamids );
				$affrows3 = $this->sqlgame->getAffectedRows();
				$this->sqlgame->cleanUpResult($res3);
				if( $affrows3 == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 5 ); }
			}
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "addserveruser", 0 );
	}
	public function editServerUser( $username, $userid, $steamids, $groups, $irc ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "accts", "form_editserveruser" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$username = isset($username) ? trim( htmlspecialchars( $username ) ) : NULL;
		$userid = isset($userid) ? trim( htmlspecialchars( $userid ) ) : NULL;
		$steamids = isset($steamids) ? trim( $steamids ) : NULL;
		$steamids .= "\r\n";
		$groups = isset($groups) ? $groups : NULL;
		$irc = isset($irc) ? trim( htmlspecialchars( $irc ) ) : NULL;
		if( is_null($username) || is_null($userid) || is_null($steamids) || is_null($groups) || is_null($irc) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		else if( preg_match( "/^((STEAM_0:)[01]{1}[:]{1}[0-9]+\r\n)+$/", $steamids ) == 0 ) { return $fr->getResponse( FormResponse::ERROR, "steamid", 3 ); }
		$steamids = trim($steamids);
		$sids = explode( "\r\n", $steamids );
		$username = $this->sqlsite->getEscapeString( $username );
		$userid = $this->sqlsite->getEscapeString( $userid );
		$irc = $this->sqlsite->getEscapeString( $irc );
		try {
			$updateStaff = "UPDATE staff SET playername = '{$username}', ircauth = '{$irc}' WHERE id = {$userid}";
			$this->sqlgame->query($updateStaff);
			$this->sqlgame->cleanUpResult($res1);
			$deleteServers = "DELETE FROM servers WHERE staffid = {$userid}";
			$res3 = $this->sqlgame->query($deleteServers);
			$this->sqlgame->cleanUpResult($res3);	
			for( $i = 0; $i < $this->sc->getServerCount(); $i++ ) {
				$groupvalue = $this->sqlsite->getEscapeString( $groups[$i] );
				$servervalue = pow( 2, $i );
				$insertServers = "INSERT INTO servers (id, servervalue, staffid, usergroupid) VALUES ( NULL, {$servervalue}, {$userid}, {$groupvalue} )";
				$res4 = $this->sqlgame->query( $insertServers );
				$affrows1 = $this->sqlgame->getAffectedRows();
				$this->sqlgame->cleanUpResult($res4);
				if( $affrows1 == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 5 ); }
			}
			$deleteSteamids = "DELETE FROM steamids WHERE staffid = {$userid}";
			$res5 = $this->sqlgame->query($deleteSteamids);
			$this->sqlgame->cleanUpResult($res5);
			for( $i = 0; $i < count($sids); $i++ ) {
				$sid = $this->sqlsite->getEscapeString( $sids[$i] );
				$insertSteamids = "INSERT INTO steamids (id, staffid, steamid) VALUES ( NULL, {$userid}, '{$sid}' )";
				$res6 = $this->sqlgame->query( $insertSteamids );
				$affrows2 = $this->sqlgame->getAffectedRows();
				$this->sqlgame->cleanUpResult($res6);
				if( $affrows2 == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 5 ); }
			}
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "editserveruser", 0 );
	}
	public function deleteServerUser( $userid ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "accts", "form_deleteserveruser" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$userid = isset( $userid ) ? trim( htmlspecialchars( $userid ) ) : NULL;
		if( is_null($userid) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$userid = $this->sqlgame->getEscapeString($userid);
		try {
			$deleteStaff = "DELETE FROM staff WHERE id = {$userid}";
			$res2 = $this->sqlgame->query( $deleteStaff );
			$this->sqlgame->cleanUpResult($res2);
			$deleteServers = "DELETE FROM servers WHERE staffid = {$userid}";
			$res3 = $this->sqlgame->query( $deleteServers );
			$this->sqlgame->cleanUpResult($res3);
			$deleteSteamid = "DELETE FROM steamids WHERE staffid = {$userid}";
			$res4 = $this->sqlgame->query( $deleteSteamid );
			$this->sqlgame->cleanUpResult($res4);
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "deleteserveruser", 0 );
	}
	public function addServerUserGroup( $name, $userlevel, $weblevel ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "accts", "form_addservergroup" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$name = isset( $name ) ? trim( htmlspecialchars( $name ) ) : NULL;
		$userlevel = isset( $userlevel ) ? trim( htmlspecialchars( $userlevel ) ) : NULL;
		$weblevel = isset( $weblevel ) ? trim( htmlspecialchars( $weblevel ) ) : NULL;
		if( is_null($name) || is_null($userlevel) || is_null($weblevel) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$name = $this->sqlsite->getEscapeString($name);
		$userlevel = $this->sqlsite->getEscapeString($userlevel);
		$weblevel = $this->sqlsite->getEscapeString($weblevel);
		$addGroup = "INSERT INTO usergroups (id, groupname, userlevel, weblevel) VALUES ( NULL, '{$name}', {$userlevel}, {$weblevel} )";
		try {
			$res = $this->sqlgame->query($addGroup);
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 5 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "addservergroup", 0 );
	}
	public function editServerUserGroup( $groupid, $name, $userlevel, $weblevel ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "accts", "form_editservergroup" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$groupid = isset( $groupid ) ? trim( htmlspecialchars( $groupid ) ) : NULL;
		$name = isset( $name ) ? trim( htmlspecialchars( $name ) ) : NULL;
		$userlevel = isset( $userlevel ) ? trim( htmlspecialchars( $userlevel ) ) : NULL;
		$weblevel = isset( $weblevel ) ? trim( htmlspecialchars( $weblevel ) ) : NULL;
		if( is_null($groupid) || is_null($name) || is_null($userlevel) || is_null($weblevel) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$groupid = $this->sqlsite->getEscapeString($groupid);
		$name = $this->sqlsite->getEscapeString($name);
		$userlevel = $this->sqlsite->getEscapeString($userlevel);
		$weblevel = $this->sqlsite->getEscapeString($weblevel);
		$editGroup = "UPDATE usergroups SET groupname = '{$name}', userlevel = {$userlevel}, weblevel = {$weblevel} WHERE id = {$groupid}";
		try {
			$res = $this->sqlgame->query($editGroup);
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "editservergroup", 0 );
	}
	public function deleteServerUserGroup( $groupid ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "accts", "form_deleteservergroup" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$groupid = isset( $groupid ) ? trim( htmlspecialchars( $groupid ) ) : NULL;
		if( is_null($groupid) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$groupid = $this->sqlsite->getEscapeString($groupid);
		$removeUserFromGroup = "UPDATE servers SET usergroupid = 1 WHERE usergroupid = {$groupid}";
		$removeGroup = "DELETE FROM usergroups WHERE id = {$groupid}";
		try {
			$res1 = $this->sqlgame->query($removeUserFromGroup);
			$this->sqlgame->cleanUpResult( $res1 );
			$res2 = $this->sqlgame->query($removeGroup);
			$this->sqlgame->cleanUpResult( $res2 );
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "deleteservergroup", 0 );
	}
	public function getServerUserGroups( $id ) {
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		if( $this->session->canAccessWebPage( "accts", "addservergroup" ) != 0 ) { return NULL; }
		$selectGroups = "SELECT id, groupname, userlevel, weblevel FROM usergroups";
		if( !is_null($id) ) {
			$id = $this->sqlsite->getEscapeString($id);
			$selectGroups .= " WHERE id = {$id}";
		}
		$selectGroups .= " ORDER BY userlevel ASC";
		$groups = array();
		try {
			$res = $this->sqlgame->query($selectGroups);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$name = $res->getValueAt( 1 );
				$userlevel = $res->getValueAt( 2 );
				$weblevel = $res->getValueAt( 3 );
				$item = array();
				$item["id"] = $id;
				$item["name"] = $name;
				$item["userlevel"] = $userlevel;
				$item["weblevel"] = $weblevel;
				$groups[$cnt] = $item;
				$cnt++;
			}
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) {
			$this->sqlgame->cleanUpResult( $res );
			return NULL;
		}
		return $groups;
	}
	public function getServerUserGroupsByUser( $userid ) {
		$userid = isset( $userid ) ? trim( htmlspecialchars( $userid ) ) : NULL;
		if( is_null($userid) ) { return NULL; }
		if( $this->session->canAccessWebPage( "accts", "addservergroup" ) != 0 ) { return NULL; }
		$userid = $this->sqlsite->getEscapeString($userid);
		$selectGroups = "SELECT t2.id, t2.servervalue, t3.id, t3.groupname, t3.userlevel, t3.weblevel FROM staff AS t1, servers AS t2, usergroups AS t3 WHERE t1.id = {$userid} AND t1.id = t2.staffid AND t2.usergroupid = t3.id ORDER BY t2.servervalue ASC";
		$servers = array();
		try {
			$res = $this->sqlgame->query($selectGroups);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$serverid = $res->getValueAt( 0 );
				$servervalue = $res->getValueAt( 1 );
				$groupid = $res->getValueAt( 2 );
				$groupname = $res->getValueAt( 3 );
				$userlevel = $res->getValueAt( 4 );
				$weblevel = $res->getValueAt( 5 );
				$item = array();
				$item["serverid"] = $serverid;
				$item["servervalue"] = $servervalue;
				$item["groupid"] = $groupid;
				$item["groupname"] = $groupname;
				$item["userlevel"] = $userlevel;
				$item["weblevel"] = $weblevel;
				$servers[$cnt] = $item;
				$cnt++;
			}
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) {
			$this->sqlgame->cleanUpResult( $res );
			return NULL;
		}
		return $servers;
	}
	public function getServerUsers( $id ) {
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		if( $this->session->canAccessWebPage( "accts", "root" ) != 0 ) { return NULL; }
		$selectUsers = "SELECT t1.id, t1.playername, t1.ircauth, t2.id, t2.servervalue, t3.id, t3.groupname, t3.userlevel, t3.weblevel FROM staff AS t1, servers AS t2, usergroups AS t3 WHERE t1.id = t2.staffid AND t2.usergroupid = t3.id";
		if( !is_null($id) ) {
			$id = $this->sqlsite->getEscapeString($id);
			$selectUsers .= " AND t1.id = {$id}";
		}
		$selectUsers .= " ORDER BY t1.id ASC, t2.servervalue ASC";
		$users = array();
		try {
			$res = $this->sqlgame->query($selectUsers);
			$item = array();
			$cnt = 0;
			$scnt = 0;
			$lastid = -1;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$playername = $res->getValueAt( 1 );
				$irc = $res->getValueAt( 2 );
				$serverid = $res->getValueAt( 3 );
				$servervalue = $res->getValueAt( 4 );
				$groupid = $res->getValueAt( 5 );
				$groupname = $res->getValueAt( 6 );
				$userlevel = $res->getValueAt( 7 );
				$weblevel = $res->getValueAt( 8 );
				if( $lastid != -1 && $lastid != $id ) {
					$users[$cnt] = $item;
					$cnt++;
					$item = array();
				}
				$lastid = $id;
				$item["id"] = $id;
				$item["username"] = $playername;
				$item["irc"] = $irc;
				if( $lastid != $id ) {
					$item["servers"] = array();
					$scnt = 0;
				}
				$serveritem = array();
				$serveritem["serverid"] = $serverid;
				$serveritem["servervalue"] = $servervalue;
				$serveritem["groupid"] = $groupid;
				$serveritem["groupname"] = $groupname;
				$serveritem["userlevel"] = $userlevel;
				$serveritem["weblevel"] = $weblevel;
				$item["servers"][$scnt] = $serveritem;
				$scnt++;
			}
			$users[$cnt] = $item;
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) {
			$this->sqlgame->cleanUpResult( $res );
			return NULL;
		}
		return $users;
	}
	public function getServerUserSteamids( $userid ) {
		$userid = isset( $userid ) ? trim( htmlspecialchars( $userid ) ) : NULL;
		if( $this->session->canAccessWebPage( "accts", "root" ) != 0 ) { return NULL; }
		if( is_null( $userid ) ) { return NULL; }
		$userid = $this->sqlsite->getEscapeString($userid);
		$selectSteamid = "SELECT t2.steamid FROM staff AS t1, steamids AS t2 WHERE t1.id = {$userid} AND t1.id = t2.staffid";
		$steamids = array();
		try {
			$res = $this->sqlgame->query($selectSteamid);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$steamid = $res->getValueAt( 0 );
				$steamids[$cnt] = $steamid;
				$cnt++;
			}
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) {
			$this->sqlgame->cleanUpResult( $res );
			return NULL;
		}
		return $steamids;
	}
	public function getAuthid2Username( $steamid ) {
		$steamid = isset( $steamid ) ? trim( htmlspecialchars( $steamid ) ) : NULL;
		if( is_null($steamid) ) { return "Unknown"; }
		$steamid = $this->sqlsite->getEscapeString( $steamid );
		$founduser = "Unknown";
		$action = "SELECT t1.username FROM users AS t1, steamids AS t2 WHERE t1.id = t2.user_id AND t2.steamid = '{$steamid}'";
		try {
			$res = $this->sqlsite->query($action);
			$founduser = "Unknown";
			if( $res->getNextRow() ) { $founduser = $res->getValueAt( 0 ); }
			$this->sqlsite->cleanUpResult( $res );
		}
		catch( MysqlException $e ) {
			$this->sqlsite->cleanUpResult( $res );
			return $e->getCode();
		}
		return $founduser;
	}
	public function __destruct() { }
	private function clear() {
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
		$this->sc = NULL;
	}
	private $sqlsite;
	private $sqlgame;
	private $session;
	private $sc;
}
class AdminCy6UI extends ObjectUI implements IObjectUI {
	public function __construct( $q, $g, $s, $sc, $i ) {
		parent::__construct();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->sc = $sc;
		$this->ip = $i;
		$this->cat = "adminroot";
		if( isset( $_REQUEST["cat"] ) ) { $this->cat = $_REQUEST["cat"]; }
		$fr = new FormResponse( $this->sqlsite );
		if( !method_exists( $this, $this->cat ) ) {
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "invalidcat", 1 ) );
			return;
		}
		if( $this->session->canAccessWebPage( $this->cat, "root" ) != 0 ) {
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "access", 2 ) );
			return;
		}
		call_user_func( array( &$this, $this->cat ) );
	}
	public function adminroot() {
		$tmpArr = array();
		$tmpArr["cat"] = "adminroot";
		$tmpArr["catreadable"] = "Admin Panel";
		if( !$this->session->isAuthed() ) { $tmpArr["tpl"] = "admin_everyone_login.tpl"; }
		else { $tmpArr["tpl"] = "admin_adminroot.tpl"; }
		$tmpArr["authed"] = $this->session->isAuthed();
		$tmpArr["ban"] = $this->session->canAccessWebPage( "ban", "root" ) == 0;
		$tmpArr["gag"] = $this->session->canAccessWebPage( "gag", "root" ) == 0;
		$tmpArr["banmgr"] = $this->session->canAccessWebPage( "manager", "root" ) == 0;
		$tmpArr["gagmgr"] = $this->session->canAccessWebPage( "manager", "root" ) == 0;
		$tmpArr["character"] = $this->session->canAccessWebPage( "character", "root" ) == 0;
		$tmpArr["log"] = $this->session->canAccessWebPage( "log", "root" ) == 0;
		$tmpArr["restrict"] = $this->session->canAccessWebPage( "restrict", "root" ) == 0;
		$tmpArr["config"] = $this->session->canAccessWebPage( "config", "root" ) == 0;
		$tmpArr["users"] = $this->session->canAccessWebPage( "users", "root" ) == 0;
		$gb = new AdminGenericBoxUI();
		$gb->initialize( $tmpArr );
		$this->generateSiteLayout( $gb->getHTML() );
	}
	public function everyone() {
		$eu = new EveryoneUI( $this->sqlsite, $this->session, $this->ip );
		$eu->processCategory();
		$this->generateSiteLayout( $eu->getHTML() );
	}
	public function ban() {
		$bu = new AdminBanUI( $this->sqlsite, $this->sqlgame, $this->session, $this->sc, $this->ip );
		$bu->processCategory();
		$this->generateSiteLayout( $bu->getHTML() );
	}
	public function gag() {
		$gu = new AdminGagUI( $this->sqlsite, $this->sqlgame, $this->session, $this->sc, $this->ip );
		$gu->processCategory();
		$this->generateSiteLayout( $gu->getHTML() );
	}
	public function log() {
		$lu = new AdminLogUI( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$lu->processCategory();
		$this->generateSiteLayout( $lu->getHTML() );
	}
	public function accts() {
		$au = new AdminAcctsUI( $this->sqlsite, $this->sqlgame, $this->session, $this->sc, $this->ip );
		$au->processCategory();
		$this->generateSiteLayout( $au->getHTML() );
	}
	public function restrict() {
		$ru = new AdminRestrictUI( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$ru->processCategory();
		$this->generateSiteLayout( $ru->getHTML() );
	}
	public function config() {
		$au = new AdminConfigUI( $this->sqlsite, $this->sqlgame, $this->session, $this->sc, $this->ip );
		$au->processCategory();
		$this->generateSiteLayout( $au->getHTML() );
	}
	public function character() {
		$cu = new AdminCharacterUI( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$cu->processCategory();
		$this->generateSiteLayout( $cu->getHTML() );
	}
	public function getHTML() { return $this->getHtmlTpl( "admin_cy6.tpl" ); }
	public function showHTML() { return $this->showHtmlTpl( "admin_cy6.tpl" ); }
	public function __destruct() { }
	private function clear() {
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
		$this->sc = NULL;
		$this->ip = NULL;
		$this->cat = NULL;
	}
	private function generateSiteLayout( $mainHtml ) {
		$keyvalue = array();
		$keyvalue["cat"] = $this->cat;
		$keyvalue["sub"] = isset( $_REQUEST["sub"] ) ? $_REQUEST["sub"] : "root";
		$sla = new AdminSiteLayoutUI( $this->sqlsite, $this->sqlgame, $this->session, $this->sc, $this->ip );
		$sla->initialize( $mainHtml, $keyvalue );
		$this->assign( "cy6", $sla->getHTML() );
	}
	private function formFunction( $fres ) {
		$fr = new AdminFormResponseUI( $this->sqlsite );
		$fr->initialize( $fres );
		$this->generateSiteLayout( $fr->getHTML() );
	}
	private $sqlsite;
	private $sqlgame;
	private $session;
	private $sc;
	private $ip;
	private $cat;
}
class AdminLogUI extends ObjectUI implements IObjectUI {
	public function __construct( $q, $g, $s, $i ) {
		parent::__construct();
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->ip = $i;
	}
	public function processCategory() {
		$this->sub = "root";
		if( isset( $_REQUEST["sub"] ) ) {
			if( $_REQUEST["sub"] != "root" ) { $this->sub = $_REQUEST["sub"]; }
		}
		$this->id = NULL;
		if( isset( $_REQUEST["id"] ) ) { $this->id = $_REQUEST["id"]; }
		$fr = new FormResponse( $this->sqlsite );
		if( !method_exists( $this, $this->sub ) ) {
			$this->sub = "error";
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "invalidsub", 1 ) );
			return;
		}
		if( $this->session->canAccessWebPage( "log", $this->sub ) != 0 ) {
			$this->sub = "error";
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "access", 2 ) );
			return;
		}
		call_user_func( array( &$this, $this->sub ) );
	}
	public function root() { }
	public function pending() {
		$offset = $this->id - ($this->id % 50);
		$l = new Logs( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$repArr = $l->getReport( 0, $offset, 50 );
		$total = $l->getReportCount( 0 );
		$this->assign( "total", $total );
		$this->assign( "offset", $offset );
		$this->assign( "prevoffset", $offset - 50 );
		$this->assign( "nextoffset", $offset + 50 );
		$this->assign( "count", count($repArr) );
		$this->assign( "items", $repArr );
		$this->assign( "subreadable", "Pending" );
		$this->assign( "sub", "pending" );
		$this->assign( "handled", FALSE );
	}
	public function handled() {
		$offset = $this->id - ($this->id % 50);
		$l = new Logs( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$repArr = $l->getReport( 1, $offset, 50 );
		$total = $l->getReportCount( 1 );
		$this->assign( "total", $total );
		$this->assign( "offset", $offset );
		$this->assign( "prevoffset", $offset - 50 );
		$this->assign( "nextoffset", $offset + 50 );
		$this->assign( "count", count($repArr) );
		$this->assign( "items", $repArr );
		$this->assign( "subreadable", "Handled" );
		$this->assign( "sub", "handled" );
		$this->assign( "handled", TRUE );
	}
	public function kick() {
		$offset = $this->id - ($this->id % 50);
		$l = new Logs( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$kickArr = $l->getLogEntries( $offset, 50 );
		$total = $l->getLogEntriesCount();
		$this->assign( "total", $total );
		$this->assign( "offset", $offset );
		$this->assign( "prevoffset", $offset - 50 );
		$this->assign( "nextoffset", $offset + 50 );
		$this->assign( "count", count($kickArr) );
		$this->assign( "logs", $kickArr );
	}
	public function vote() {
		$offset = $this->id - ($this->id % 50);
		$l = new Logs( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$voteArr = $l->getVoteLogs( $offset, 50 );
		$total = $l->getVoteLogsCount();
		$this->assign( "total", $total );
		$this->assign( "offset", $offset );
		$this->assign( "prevoffset", $offset - 50 );
		$this->assign( "nextoffset", $offset + 50 );
		$this->assign( "count", count($voteArr) );
		$this->assign( "logs", $voteArr );
	}
	public function form_handled() {
		$l = new Logs( $this->sqlsite, $this->sqlgame, $this->session, $this->ip );
		$fres = $l->handleReport( $this->id );
		$this->formFunction( $fres );
	}
	public function getHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->getHtmlTpl( "admin_log_root.tpl" );
			break;
			case "pending":
			case "handled":
			return $this->getHtmlTpl( "admin_log_report.tpl" );
			break;
			case "kick":
			return $this->getHtmlTpl( "admin_log_kick.tpl" );
			break;
			case "vote":
			return $this->getHtmlTpl( "admin_log_vote.tpl" );
			break;
			default:
			return $this->getHtmlTpl( "admin_log.tpl" );
		}
	}
	public function showHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->showHtmlTpl( "admin_log_root.tpl" );
			break;
			case "pending":
			case "handled":
			return $this->showHtmlTpl( "admin_log_report.tpl" );
			break;
			case "kick":
			return $this->showHtmlTpl( "admin_log_kick.tpl" );
			break;
			case "vote":
			return $this->showHtmlTpl( "admin_log_vote.tpl" );
			break;
			default:
			return $this->showHtmlTpl( "admin_log.tpl" );
		}
	}
	public function __destruct() { }
	private function clear() {
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
		$this->ip = NULL;
		$this->id = NULL;
		$this->sub = NULL;
	}
	private function formFunction( $fres ) {
		$fr = new AdminFormResponseUI( $this->sqlsite );
		$fr->initialize( $fres );
		$this->assign( "log", $fr->getHTML() );
	}
	private $sqlsite;
	private $sqlgame;
	private $session;
	private $ip;
	private $id;
	private $sub;
}
class AdminSiteLayoutUI extends ObjectUI implements IObjectUI {
	public function __construct( $q, $g, $s, $sc, $i ) {
		parent::__construct();
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->sc = $sc;
		$this->ip = $i;
	}
	public function initialize( $mainHtml, $keyvalue ) {
		$this->assign( "authed", $this->session->isAuthed() );
		$this->assign( "publicunban", $this->sc->getPublicUnban() );
		$this->assign( "ban", $this->session->canAccessWebPage( "ban", "root" ) == 0 );
		$this->assign( "gag", $this->session->canAccessWebPage( "gag", "root" ) == 0 );
		$this->assign( "banmgr", $this->session->canAccessWebPage( "manager", "root" ) == 0 );
		$this->assign( "gagmgr", $this->session->canAccessWebPage( "manager", "root" ) == 0 );
		$this->assign( "character", $this->session->canAccessWebPage( "character", "root" ) == 0 );
		$this->assign( "log", $this->session->canAccessWebPage( "log", "root" ) == 0 );
		$this->assign( "restrict", $this->session->canAccessWebPage( "restrict", "root" ) == 0 );
		$this->assign( "config", $this->session->canAccessWebPage( "config", "root" ) == 0 );
		$this->assign( "users", $this->session->canAccessWebPage( "users", "root" ) == 0 );
		$this->assign( "right", $mainHtml );
	}
	public function getHTML() { return $this->getHtmlTpl( "admin_sitelayout.tpl" ); }
	public function showHTML() { $this->showHtmlTpl( "admin_sitelayout.tpl" ); }
	public function __destruct() { }
	private function clear() {
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
		$this->sc = NULL;
		$this->ip = NULL;
	}
	private $sqlsite;
	private $sqlgame;
	private $session;
	private $sc;
	private $ip;
}
class BanGagCommon {
	const UNKNOWN = 0;
	const BAN = 1;
	const GAG = 2;
	const LOG_BAN = 1;
	const LOG_GAG = 2;
	const LOG_KICK = 3;
	public function __construct( $q, $g, $s, $sc, $t ) {
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->sc = $sc;
		$this->type = $t;
	}
	public function getCollectionCount( $search, $flags ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "root" ) != 0 ) { return NULL; }
		$flags = isset( $flags ) ? trim( htmlspecialchars( $flags ) ) : NULL;
		$search = isset( $search ) ? trim( htmlspecialchars( $search ) ) : NULL;
		$table = "";
		switch( $this->type ) {
			case self::GAG:
			$table = "gagged";
			break;
			case self::BAN:
			$table = "banned";
			break;
			default:
			return NULL;
		}
		$selectQuery = "SELECT COUNT(id) FROM {$table}";
		$first = FALSE;
		if( !is_null($flags) ) {
			$first = TRUE;
			$flags = $this->sqlsite->getEscapeString($flags);
			$selectQuery .= " WHERE status & {$flags} = {$flags}";
		}
		if( !is_null($search) ) {
			if( !$first ) { $selectQuery .= " WHERE"; }
			else { $selectQuery .= " AND"; }
			$selectQuery .= " (steamid REGEXP '{$search}' OR name REGEXP '{$search}') ";
		}
		$selectQuery .= " ORDER BY id ASC";
		$cnt = $this->sqlgame->count($selectQuery);
		return $cnt;
	}
	public function getPendingActions() {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "verify" ) != 0 ) { return NULL; }
		$table = "";
		switch( $this->type ) {
			case self::GAG:
			$table = "gagged";
			break;
			case self::BAN:
			$table = "banned";
			break;
			default:
			return NULL;
		}
		$selectQuery = "SELECT id, steamid, name, time, actionid, reason, reactreason, server, timestamp, status FROM {$table} WHERE status & 3 != 0 ORDER BY id ASC";
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$resArray = array();
		try {
			$res = $this->sqlgame->query($selectQuery);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$steamid = $res->getValueAt( 1 );
				$name = $res->getValueAt( 2 );
				$time = $res->getValueAt( 3 );
				$admin = $res->getValueAt( 4 );
				$reason = $res->getValueAt( 5 );
				$reactreason = $res->getValueAt( 6 );
				$server = $res->getValueAt( 7 );
				$timestamp = $res->getValueAt( 8 );
				$status = $res->getValueAt( 9 );
				$pos = 1;
				for( $pos = 1; $bannedserver > 0; $pos++ ) {
					$bannedserver = $bannedserver >> 1;
					if( $bannedserver <= 0 ) { break; }
				}
				$strserver = "Error";
				if( $pos != 0 ) { $strserver = $this->sc->getNameAt( $pos - 1 ); }
				$item = array();
				$item["id"] = $id;
				$item["steamid"] = $steamid;
				$item["name"] = $name;
				$item["time"] = $time;
				$item["admin"] = $a->getAuthid2Username( $admin );
				$item["reason"] = $reason;
				$item["reactreason"] = $reactreason;
				$item["serverid"] = $serverid;
				$item["servername"] = $strserver;
				$item["timestamp"] = date( "D M j G:i:s Y", $timestamp );
				$item["status"] = $status;
				$resArray[$cnt] = $item;
				$cnt++;
			}
		}
		catch( MysqlException $e ) { return NULL; }
		return $resArray;
	}
	public function getCollection( $search, $flags, $offset, $limit ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "root" ) != 0 ) { return NULL; }
		$search = isset( $search ) ? trim( htmlspecialchars( $search ) ) : NULL;
		$flags = isset( $flags ) ? trim( htmlspecialchars( $flags ) ) : NULL;
		$offset = isset( $offset ) ? trim( htmlspecialchars( $offset ) ) : NULL;
		$limit = isset( $limit ) ? trim( htmlspecialchars( $limit ) ) : NULL;
		if( is_null($offset) || is_null($limit) ) { return NULL; }
		$table = "";
		switch( $this->type ) {
			case self::GAG:
			$table = "gagged";
			break;
			case self::BAN:
			$table = "banned";
			break;
			default:
			return NULL;
		}
		$offset = $this->sqlsite->getEscapeString($offset);
		$limit = $this->sqlsite->getEscapeString($limit);
		$selectQuery = "SELECT id, steamid, name, time, actionid, reason, server, timestamp, status FROM {$table}";
		$first = FALSE;
		if( !is_null($flags) ) {
			$first = TRUE;
			$flags = $this->sqlsite->getEscapeString($flags);
			$selectQuery .= " WHERE status & {$flags} = {$flags}";
		}
		if( !is_null($search) ) {
			if( !$first ) { $selectQuery .= " WHERE"; }
			else { $selectQuery .= " AND"; }
			$search = $this->sqlsite->getEscapeString($search);
			$selectQuery .= " (steamid REGEXP '{$search}' OR name REGEXP '{$search}')";
		}
		$selectQuery .= " ORDER BY id ASC LIMIT {$offset}, {$limit}";
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$resArray = array();
		try {
			$res = $this->sqlgame->query($selectQuery);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$steamid = $res->getValueAt( 1 );
				$name = $res->getValueAt( 2 );
				$time = $res->getValueAt( 3 );
				$admin = $res->getValueAt( 4 );
				$reason = $res->getValueAt( 5 );
				$server = $res->getValueAt( 6 );
				$timestamp = $res->getValueAt( 7 );
				$status = $res->getValueAt( 8 );
				$pos = 1;
				for( $pos = 1; $bannedserver > 0; $pos++ ) {
					$bannedserver = $bannedserver >> 1;
					if( $bannedserver <= 0 ) { break; }
				}
				$strserver = "Error";
				if( $pos != 0 ) { $strserver = $this->sc->getNameAt( $pos - 1 ); }
				$item = array();
				$item["id"] = $id;
				$item["steamid"] = $steamid;
				$item["name"] = $name;
				$item["time"] = $time;
				$item["admin"] = $a->getAuthid2Username( $admin );
				$item["reason"] = $reason;
				$item["serverid"] = $serverid;
				$item["servername"] = $strserver;
				$item["timestamp"] = date( "D M j G:i:s Y", $timestamp );
				$item["status"] = $status;
				$resArray[$cnt] = $item;
				$cnt++;
			}
		}
		catch( MysqlException $e ) { return NULL; }
		return $resArray;
	}
	public function getLogEntriesCount() {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "log" ) != 0 ) { return NULL; }
		$logtype = self::UNKNOWN;
		switch( $this->type ) {
			case self::GAG:
			$logtype = self::LOG_GAG;
			break;
			case self::BAN:
			$logtype = self::LOG_BAN;
			break;
			case self::KICK:
			$logtype = self::LOG_KICK;
			break;
			default:
			return NULL;
		}
		$selectQuery = "SELECT COUNT(id) FROM logged WHERE type = {$logtype} ORDER BY timestamp DESC";
		$cnt = $this->sqlgame->count($selectQuery);
		return $cnt;
	}
	public function getLogEntries( $offset, $limit ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "log" ) != 0 ) { return NULL; }
		$offset = isset( $offset ) ? trim( htmlspecialchars( $offset ) ) : NULL;
		$limit = isset( $limit ) ? trim( htmlspecialchars( $limit ) ) : NULL;
		if( is_null($offset) || is_null($limit) ) { return NULL; }
		$logtype = self::UNKNOWN;
		switch( $this->type ) {
			case self::GAG:
			$logtype = self::LOG_GAG;
			break;
			case self::BAN:
			$logtype = self::LOG_BAN;
			break;
			case self::KICK:
			$logtype = self::LOG_KICK;
			break;
			default:
			return NULL;
		}
		$offset = $this->sqlsite->getEscapeString($offset);
		$limit = $this->sqlsite->getEscapeString($limit);
		$queryLog = "SELECT id, timestamp, actionid, actionname, receiveid, receivename, action FROM logged WHERE type = {$logtype} ORDER BY timestamp DESC LIMIT {$offset}, {$limit}";
		$resArray = array();
		try {
			$res = $this->sqlgame->query($queryLog);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$timestamp = $res->getValueAt( 1 );
				$adminid = $res->getValueAt( 2 );
				$adminname = $res->getValueAt( 3 );
				$receiveid = $res->getValueAt( 4 );
				$receivename = $res->getValueAt( 5 );
				$action = $res->getValueAt( 6 );
				$item = array();
				$item["id"] = $id;
				$item["name"] = $receivename;
				$item["steamid"] = $receiveid;
				$item["admin"] = $adminname;
				$item["timestamp"] = date( "D M j G:i:s Y", $timestamp );
				$item["action"] = $action;
				$resArray[$cnt] = $item;
				$cnt++;
			}
		}
		catch( MysqlException $e ) { return NULL; }
		return $resArray;
	}
	public function setPermanent( $id ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "add" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		if( is_null($id) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$table = "";
		$short = "";
		switch( $this->type ) {
			case self::GAG:
			{
				$table = "gagged";
				$short = "gag";
			}
			break;
			case self::BAN:
			{
				$table = "banned";
				$short = "ban";
			}
			break;
			default:
			{
				return $fr->getResponse( FormResponse::ERROR, "invalidcat", 3 );
			}
		}
		$id = $this->sqlsite->getEscapeString($id);
		$timestamp = time();
		try {
			$pbanUpdate = "";
			if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "verify" ) == 0 ) {
				$pbanUpdate = "UPDATE {$table} SET status = 20, time = 0, action = 0, timestamp = {$timestamp} WHERE id = {$id}";
			}
			else {
				$pbanUpdate = "UPDATE {$table} SET status = 14, action = 0, timestamp = {$timestamp} WHERE id = {$id}";
			}
			$res1 = $this->sqlgame->query($pbanUpdate);
			$this->sqlgame->cleanUpResult($res1);
			$selectQuery = "SELECT steamid, name, reason FROM {$table} WHERE id = {$id}";
			$res2 = $this->sqlgame->query($selectQuery);
			if( !$res2->getNextRow() ) { return $fr->getResponse( FormResponse::ERROR, "norecords", 5 ); }
			$baneeSteamid = $res2->getValueAt( 0 );
			$baneeName = $res2->getValueAt( 1 );
			$baneeReason = $res2->getValueAt( 2 );
			$this->sqlgame->cleanUpResult($res2);
			$mySteamids = $this->session->getSteamIds( $this->session->getUserId() );
			$logAction = "{$this->session->getUsername()} ({$mySteamids[0]}) ";
			if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "verify" ) == 0 ) {
				$logAction .= "{$table} ";
			}
			else {
				$logAction .= "requested a permanent {$short} ";
			}
			$logAction .= "on {$baneeName} ({$baneeSteamid}) because {$baneeReason}.";
			$logInsert = "INSERT INTO logged (id, type, timestamp, actionid, actionname, receiveid, receivename, action) VALUES ( NULL, {$this->type}, '{$timestamp}', '{$mySteamids[0]}', '{$this->session->getUsername()}', '{$baneeSteamid}', '{$baneeName}', '{$logAction}' )";
			$res3 = $this->sqlgame->query($logInsert);
			$this->sqlgame->cleanUpResult($res3);
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, $short, 0 );
	}
	public function addNewItem( $name, $steamid, $reason ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "add" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$name = isset( $name ) ? trim( htmlspecialchars( $name ) ) : NULL;
		$steamid = isset( $steamid ) ? trim( htmlspecialchars( $steamid ) ) : NULL;
		$reason = isset( $reason ) ? trim( htmlspecialchars( $reason ) ) : NULL;
		if( is_null($name) || is_null($steamid) || is_null($reason) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		else if( preg_match( "/^(STEAM_0:)[01]{1}[:]{1}[0-9]+$/", $steamid ) == 0 ) { return $fr->getResponse( FormResponse::ERROR, "steamid", 3 ); }
		$table = "";
		$short = "";
		switch( $this->type ) {
			case self::GAG:
			{
				$table = "gagged";
				$short = "gag";
			}
			break;
			case self::BAN:
			{
				$table = "banned";
				$short = "ban";
			}
			break;
			default:
			{
				return $fr->getResponse( FormResponse::ERROR, "invalidcat", 4 );
			}
		}
		$name = $this->sqlsite->getEscapeString( $name );
		$steamid = $this->sqlsite->getEscapeString( $steamid );
		$reason = $this->sqlsite->getEscapeString( $reason );
		$mysteamid = $this->session->getSteamIds( $this->session->getUserId() );
		$username = $this->session->getUsername();
		$timestamp = time();
		$addAction = "INSERT INTO {$table} (id, steamid, name, timestamp, time, status, server, action, actionid, reactionid, reason, reactreason) VALUES ( NULL, '{$steamid}', '{$name}', '{$timestamp}', 0, ";
		if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "verify" ) == 0 ) { $addAction .= "20"; }
		else { $addAction .= "18"; }
		$addAction .= ", 1, 0, '{$mysteamid[0]}', 0, '{$reason}', 'NA' )";
		$logAction = "{$username} ({$mysteamid[0]}) ";
		if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "verify" ) == 0 ) {
			$logAction .= "{$table} ";
		}
		else {
			$logAction .= "requested a permanent {$short} ";
		}
		$logAction .= "on {$name} ({$steamid}) because {$reason}.";
		$logInsert = "INSERT INTO logged (id, type, timestamp, actionid, actionname, receiveid, receivename, action) VALUES ( NULL, {$this->type}, '{$timestamp}', '{$mysteamid[0]}', '{$username}', '{$steamid}', '{$name}', '{$logAction}' )";
		try {
			$res1 = $this->sqlgame->query( $addAction );
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res1 );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 5 ); }
			$res2 = $this->sqlgame->query($logInsert);
			$this->sqlgame->cleanUpResult($res2);
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, $short, 0 );
	}
	public function deleteOldItem( $id, $reason ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "remove" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		$reason = isset( $reason ) ? trim( htmlspecialchars( $reason ) ) : NULL;
		if( is_null($id) || is_null($reason) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$table = "";
		$short = "";
		switch( $this->type ) {
			case self::GAG:
			{
				$table = "gagged";
				$short = "ungag";
			}
			break;
			case self::BAN:
			{
				$table = "banned";
				$short = "unban";
			}
			break;
			default:
			{
				return $fr->getResponse( FormResponse::ERROR, "invalidcat", 3 );
			}
		}
		$id = $this->sqlsite->getEscapeString( $id );
		$reason = $this->sqlsite->getEscapeString( $reason );
		$querySelect = "SELECT name, status, steamid FROM {$table} WHERE id = {$id}";
		$mysteamid = $this->session->getSteamIds( $this->session->getUserId() );
		$username = $this->session->getUsername();
		$timestamp = time();
		try {
			$res1 = $this->sqlgame->query($querySelect);
			if( !$res1->getNextRow() ) { return $fr->getResponse( FormResponse::ERROR, "norecords", 4 ); }
			$name = $res1->getValueAt( 0 );
			$status = $res1->getValueAt( 1 );
			$steamid = $res1->getValueAt( 2 );
			$this->sqlgame->cleanUpResult( $res1 );
			$removeUpdate = "UPDATE {$table} SET ";
			if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "verify" ) == 0 ) { $removeUpdate .= "status = 32, action = 0, "; }
			else {
				$bits = 3;
				$unbanstatus = ($unbanstatus & (~ $bits)) | 1;
				$removeUpdate .= "status = {$unbanstatus}, ";
			}
			$removeUpdate .= "reactionid = '{$mysteamid[0]}', reactreason = '{$reason}', timestamp = {$timestamp} WHERE id = {$id}";
			$res2 = $this->sqlgame->query( $removeUpdate );
			$this->sqlgame->cleanUpResult( $res2 );
			$logAction = "{$username} ({$mysteamid[0]}) ";
			if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "verify" ) == 0 ) {
				$logAction .= "un{$table} ";
			}
			else {
				$logAction .= "requested to {$short} ";
			}
			$logAction .= "{$name} ({$steamid}) because {$reason}.";
			$insertAction = "INSERT INTO logged (id, type, timestamp, actionid, actionname, receiveid, receivename, action) VALUES ( NULL, 1, '{$timestamp}', '{$mysteamid[0]}', '{$username}', '{$steamid}', '{$name}', '{$logAction}' )";
			$res3 = $this->sqlgame->query( $insertAction );
			$this->sqlgame->cleanUpResult( $res3 );			
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, $short, 0 );
	}
	public function deletePublicOldItem( $steamid, $reason ) {
		$fr = new FormResponse( $this->sqlsite );
		$steamid = isset( $steamid ) ? trim( htmlspecialchars( $steamid ) ) : NULL;
		$reason = isset( $reason ) ? trim( htmlspecialchars( $reason ) ) : NULL;
		if( is_null($steamid) || is_null($reason) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$table = "";
		$short = "";
		switch( $this->type ) {
			case self::GAG:
			{
				$table = "gagged";
				$short = "ungag";
			}
			break;
			case self::BAN:
			{
				$table = "banned";
				$short = "unban";
			}
			break;
			default:
			{
				return $fr->getResponse( FormResponse::ERROR, "invalidcat", 3 );
			}
		}
		$steamid = $this->sqlsite->getEscapeString( $steamid );
		$reason = $this->sqlsite->getEscapeString( $reason );
		try {
			$removeUpdate = "UPDATE {$table} SET status = status | 1, reactreason = '{$reason}' WHERE steamid = '{$steamid}'";
			$res = $this->sqlgame->query( $removeUpdate );
			$this->sqlgame->cleanUpResult( $res );			
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "public{$short}", 0 );
	}
	public function verifyActionItems( $approve ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( $this->type == self::GAG ? "gag" : "ban", "verify" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$approve = isset( $approve ) ? $approve : NULL;
		if( is_null($approve) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$table = "";
		$short = "";
		switch( $this->type ) {
			case self::GAG:
			{
				$table = "gagged";
				$short = "gag";
			}
			break;
			case self::BAN:
			{
				$table = "banned";
				$short = "ban";
			}
			break;
			default:
			{
				return $fr->getResponse( FormResponse::ERROR, "invalidcat", 3 );
			}
		}
		$mysteamid = $this->session->getSteamIds( $this->session->getUserId() );
		$username = $this->session->getUsername();
		$timestamp = time();
		$verifySelect = "SELECT id, steamid, name, status FROM {$table} WHERE (status & 3) != 0 ORDER BY id ASC";
		try {
			$res1 = $this->sqlgame->query( $verifySelect );
			$cnt = 0;
			while( $res1->getNextRow() ) {
				$id = $res1->getValueAt( 0 );
				$steamid = $res1->getValueAt( 1 );
				$name = $res1->getValueAt( 2 );
				$status = $res1->getValueAt( 3 );
				$verifyUpdate = "";
				$whichAction = "";
				if( ($status & 2) == 2 ) {
					$whichAction = "{$short}";
					$verifyUpdate = "UPDATE {$table} SET status = 20, action = 0, time = 0, timestamp = {$timestamp} WHERE id = {$id}";
				}
				else if( ($status & 1) == 1 ) {
					$whichAction = "un{$short}";
					$verifyUpdate = "UPDATE {$table} SET status = 32, action = 0, time = 0, timestamp = {$timestamp} WHERE id = {$id}";
				}
				if( strcasecmp( $approve[$cnt], "Y" ) == 0 ) {
					$res2 = $this->sqlgame->query($verifyUpdate);
					$this->sqlgame->cleanUpResult($res2);
					$logAction = "The Lead Admin, {$username} ({$mysteamid[0]}), approved the {$whichAction} of {$name} ({$steamid}).";
					$insertAction = "INSERT INTO logged (id, type, timestamp, actionid, actionname, receiveid, receivename, action) VALUES ( NULL, 1, '{$timestamp}', '{$mysteamid[0]}', '{$username}', '{$steamid}', '{$name}', '{$logAction}' )";
					$res3 = $this->sqlgame->query( $insertAction );
					$this->sqlgame->cleanUpResult($res3);
				}
				else if( strcasecmp( $approve[$cnt], "N" ) == 0 ) {
					if( ($status & 4) == 0 ) {
						$deleteQuery = "DELETE FROM {$table} WHERE id = {$id}";
						$res2 = $this->sqlgame->query( $deleteQuery );
						$this->sqlgame->cleanUpResult($res2);
					}
					else {
						$statusTemp = $status - ($status & 3);
						$updateQuery = "UPDATE {$table} SET status = {$statusTemp} WHERE id = {$id}";
						$res2 = $this->sqlgame->query( $updateQuery );
						$this->sqlgame->cleanUpResult($res2);
					}
				}
				$cnt++;
			}
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", 3 ); }
		return $fr->getResponse( FormResponse::THANKYOU, "verify", 0 );
	}
	public function __destruct() { }
	protected function clear() {
		$this->sql = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
		$this->sc = NULL;
		$this->sc = self::UNKNOWN;
	}
	protected $sqlsite;
	protected $sqlgame;
	protected $session;
	protected $sc;
	protected $type;
}
class ServerConfig {
	public function __construct( $q, $g, $s, $sc ) {
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->sc = $sc;
	}
	public function getAdCount() {
		if( !$this->session->isAuthed() ) { return 0; }
		if( $this->session->canAccessWebPage( "config", "root" ) != 0 ) { return 0; }
		$selectQuery = "SELECT COUNT(t1.id) FROM ads AS t1, configurations AS t2 WHERE t1.configuration_id = t2.id AND t2.id != 1";
		$cnt = $this->sqlgame->count($selectQuery);
		return $cnt;
	}
	public function getAds( $id, $offset, $limit ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( "config", "root" ) != 0 ) { return NULL; }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		$offset = isset( $offset ) ? trim( htmlspecialchars( $offset ) ) : NULL;
		$limit = isset( $limit ) ? trim( htmlspecialchars( $limit ) ) : NULL;
		$selectQuery = "SELECT t1.id, t1.configuration_id, t1.advertisement, t2.name, t2.server FROM ads AS t1, configurations AS t2 WHERE t1.configuration_id = t2.id AND t2.id != 1";
		if( !is_null($id) ) {
			$id = $this->sqlsite->getEscapeString($id);
			$selectQuery .= " AND configuration_id = {$id}";
		}
		if( !is_null($offset) && !is_null($limit) ) {
			$offset = $this->sqlsite->getEscapeString($offset);
			$limit = $this->sqlsite->getEscapeString($limit);
			$selectQuery .= " LIMIT {$offset}, {$limit}";
		}
		$resArray = array();
		try {
			$res = $this->sqlgame->query($selectQuery);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$configid = $res->getValueAt( 1 );
				$advert = $res->getValueAt( 2 );
				$servername = $res->getValueAt( 3 );
				$servervalue = $res->getValueAt( 4 );
				$item = array();
				$item["id"] = $id;
				$item["configid"] = $configid;
				$item["advertisement"] = $advert;
				$item["servername"] = $servername;
				$item["servervalue"] = $servervalue;
				$resArray[$cnt] = $item;
				$cnt++;
			}
			$this->sqlsite->cleanUpResult( $res );
		}
		catch( MysqlException $e ) {
			$this->sqlsite->cleanUpResult( $res );
			return NULL;
		}
		return $resArray;
	}
	public function getConfig( $id, $removeZero ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( "config", "edit" ) != 0 ) { return NULL; }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		$removeZero = isset( $removeZero ) ? $removeZero : FALSE;
		$selectConfig = "SELECT id, name, server, config FROM configurations";
		$foundWhere = FALSE;
		if( !is_null($id) ) {
			$foundWhere = TRUE;
			$id = $this->sqlgame->getEscapeString($id);
			$selectConfig .= " WHERE id = {$id}";
		}
		if( $removeZero ) {
			if( !$foundWhere ) { $selectConfig .= " WHERE"; }
			else { $selectConfig .= " AND"; }
			$selectConfig .= " id != 1";
		}
		$myarray = array();
		try {
			$res = $this->sqlgame->query($selectConfig);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$name = $res->getValueAt( 1 );
				$server = $res->getValueAt( 2 );
				$config = $res->getValueAt( 3 );
				$item = array();
				$item["id"] = $id;
				$item["name"] = $name;
				$item["server"] = $server;
				$item["config"] = $config;
				$myarray[$cnt] = $item;
				$cnt++;
			}
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return NULL; }
		return $myarray;
	}
	public function getMapcycle( $id ) {
		if( $id >= $this->sc->getServerCount() ) { return NULL; }
		$lines = file( $this->sc->getHLDSPathAt($id) . "/" . $this->sc->getModAt($id) . "/mapcycle.txt" );
		return $lines;
	}
	public function getMapsAvailable( $id ) {
		if( $id >= $this->sc->getServerCount() ) { return NULL; }
		$resArr = array();
		$cnt = 0;
		$diary_directory = opendir( $this->sc->getHLDSPathAt($id) . "/" . $this->sc->getModAt($id) . "/maps/" );
		while( $filename = readdir($diary_directory) ) {
			$lastcnt = strrpos( $filename, "." );
			$fileextension = substr( $filename, ($lastcnt + 1) );
			if( strcasecmp( $fileextension, "bsp" ) == 0 ) {
				$filename = str_replace( ".bsp", "", $filename );
				$resArr[$cnt] = $filename;
				$cnt++;
			}
		}
		closedir($diary_directory);
		return $resArr;
	}
	public function addNewCfg( $name, $data ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "config", "form_add" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$name = isset( $name ) ? trim( htmlspecialchars( $name ) ) : NULL;
		$data = isset( $data ) ? trim( $data ) : NULL;
		if( is_null($name) || is_null($data) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$name = $this->sqlgame->getEscapeString( $name );
		$data = $this->sqlgame->getEscapeString( $data );
		$insertQuery = "INSERT INTO configurations (id, name, server, config) VALUES ( NULL, '{$name}', 0, '{$data}' )";
		try {
			$res = $this->sqlgame->query( $insertQuery );
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "addcfg", 0 );
	}
	public function editCfg( $id, $data, $activate ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "config", "form_edit" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		$data = isset( $data ) ? trim( $data ) : NULL;
		$activate = isset( $activate ) ? $activate : NULL;
		if( is_null($id) || is_null($data) || is_null($activate) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$id = $this->sqlgame->getEscapeString( $id );
		$data = $this->sqlgame->getEscapeString( $data );
		$status = 0;
		for( $i = 0; $i < $this->sc->getServerCount(); $i++ ) {
			$act = $activate[$i];
			if( !strcasecmp( $act, "Y" ) ) { $status = $status | pow( 2, $i ); }
		}
		$updateDisable = "UPDATE configurations SET server = (server & ~{$status}) WHERE (server & {$status}) != 0";
		$updateCfg = "UPDATE configurations SET server = {$status}, config = '{$data}' WHERE id = {$id}";
		try {
			if( $status != 0 ) {
				$res1 = $this->sqlgame->query( $updateDisable );
				$this->sqlgame->cleanUpResult( $res1 );
			}
			$res2 = $this->sqlgame->query( $updateCfg );
			$this->sqlgame->cleanUpResult( $res2 );
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "editcfg", 0 );
	}
	public function copyCfg( $id, $name ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "config", "form_copy" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		$name = isset( $name ) ? trim( htmlspecialchars( $name ) ) : NULL;
		if( is_null($id) || is_null($name) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$id = $this->sqlgame->getEscapeString( $id );
		$name = $this->sqlgame->getEscapeString( $name );
		$insertCopy = "INSERT INTO configurations (id, name, server, config) SELECT NULL, '{$name}', 0, config FROM configurations WHERE id = {$id}";
		try {
			$res = $this->sqlgame->query( $insertCopy );
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "copycfg", 0 );
	}
	function deleteCfg( $id ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "config", "form_delete" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		if( is_null($id) || $id == 1 ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$id = $this->sqlgame->getEscapeString( $id );
		$deleteCfg = "DELETE FROM configurations WHERE id = {$id} AND server = 0";
		try {
			$res = $this->sqlgame->query( $deleteCfg );
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "deletecfg", 0 );
	}
	function addAd( $id, $ad ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "config", "root" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		$ad = isset( $ad ) ? trim( htmlspecialchars( $ad ) ) : NULL;
		if( is_null($id) || is_null($ad) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$id = $this->sqlgame->getEscapeString( $id );
		$ad = $this->sqlgame->getEscapeString( $ad );
		$insertAd = "INSERT INTO ads (id, configuration_id, advertisement) VALUE ( NULL, {$id}, '{$ad}' )";
		try {
			$res = $this->sqlgame->query( $insertAd );
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "addad", 0 );
	}
	function deleteAd( $id ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "config", "root" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		if( is_null($id) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$id = $this->sqlgame->getEscapeString( $id );
		$deleteAd = "DELETE FROM ads WHERE id = {$id}";
		try {
			$res = $this->sqlgame->query( $deleteAd );
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "deletead", 0 );
	}
	public function updateMapcycle( $id, $cycle ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "config", "root" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		$cycle = isset( $cycle ) ? trim( htmlspecialchars( $cycle ) ) : NULL;
		if( is_null($cycle) || is_null($id) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$fw = fopen( $this->sc->getHLDSPathAt($id) . "/" . $this->sc->getModAt($id) . "/mapcycle.txt", "w" );
		fwrite( $fw, $cycle );
		fclose( $fw );
		return $fr->getResponse( FormResponse::THANKYOU, "mapcycle", 0 );
	}
	public function uploadMap( $id, $uploadbsp, $uploadtxt ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "config", "root" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		$uploadbsp = isset( $uploadbsp ) ? trim( htmlspecialchars( $uploadbsp ) ) : NULL;
		$uploadtxt = isset( $uploadtxt ) ? trim( htmlspecialchars( $uploadtxt ) ) : NULL;
		if( is_null($id) || is_null($uploadbsp) || is_null($uploadtxt) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$bspfilename = $_FILES["{$uploadbsp}"]["name"];
		$bsptmpfilename = $_FILES["{$uploadbsp}"]["tmp_name"];
		if( preg_match( "/(.bsp)$/", $_FILES["{$uploadbsp}"]["name"] ) == 0 ) { return $fr->getResponse( FormResponse::ERROR, "fileformat", 3 ); }
		$newbspname = $this->sc->getHLDSPathAt($id) . "/" . $this->sc->getModAt($id) . "/maps/" . $_FILES["{$uploadbsp}"]["name"];
		if( !move_uploaded_file( $_FILES["{$uploadbsp}"]["tmp_name"], $newbspname ) ) { return $fr->getResponse( FormResponse::ERROR, "filemove", 5 ); }
		if( !is_null($uploadtxt) ) {
			$txtfilename = $_FILES["{$uploadtxt}"]["name"];
			$txttmpfilename = $_FILES["{$uploadtxt}"]["tmp_name"];
			if( preg_match( "/(.txt)$/", $_FILES["{$uploadtxt}"]["name"] ) == 0 ) { return $fr->getResponse( FormResponse::ERROR, "fileformat", 4 ); }
		}
		$newtxtname = $this->sc->getHLDSPathAt($id) . "/" . $this->sc->getModAt($id) . "/maps/" . $_FILES["{$uploadtxt}"]["name"];
		if( !move_uploaded_file( $_FILES["{$uploadtxt}"]["tmp_name"], $newtxtname ) ) { return $fr->getResponse( FormResponse::ERROR, "filemove", 6 ); }
		return $fr->getResponse( FormResponse::THANKYOU, "upload", 0 );
	}
	public function __destruct() { }
	private function clear() {
		$this->session = NULL;
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->sc = NULL;
	}
	private $session;
	private $sqlsite;
	private $sqlgame;
	private $sc;
}
class AdminGenericBoxUI extends ObjectUI implements IObjectUI {
	public function __construct() {
		parent::__construct();
		$this->tpl = NULL;
	}
	public function initialize( $keyvalue ) {
		foreach( $keyvalue as $key => $value ) {
			if( $key == "tpl" ) { $this->tpl = $value; }
			else { $this->assign( $key, $value ); }
		}
	}
	public function getHTML() {
		if( is_null($this->tpl) ) { return NULL; }
		return $this->getHtmlTpl( $this->tpl );
	}
	public function showHTML() {
		if( is_null($this->tpl) ) { return NULL; }
		return $this->showHtmlTpl( $this->tpl );
	}
	public function __destruct() { }
	private $tpl;
}
class EveryoneUI extends ObjectUI implements IObjectUI {
	public function __construct( $q, $s, $i ) {
		parent::__construct();
		$this->clear();
		$this->sql = $q;
		$this->session = $s;
		$this->ip = $i;
	}
	public function processCategory() {
		$this->sub = "root";
		if( isset( $_REQUEST["sub"] ) ) { $this->sub = $_REQUEST["sub"]; }
		$this->id = NULL;
		if( isset( $_REQUEST["id"] ) ) { $this->id = $_REQUEST["id"]; }
		if( !method_exists( $this, $this->sub ) ) {
			$fr = new FormResponse( $this->sql );
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "invalidsub", 1 ) );
		}
		call_user_func( array( &$this, $this->sub ) );
	}
	public function root() { $this->assign( "authed", $this->session->isAuthed() ); }
	public function login() { $this->assign( "authed", $this->session->isAuthed() ); }
	public function change() { $this->assign( "authed", $this->session->isAuthed() ); }
	function form_login() {
		$ce = new CatEveryone( $this->sql, $this->session );
		$fres = $ce->loginForm( $_POST["username"], $_POST["password"], $this->ip );
		$this->formFunction( $fres );
	}
	public function form_resetpassword() {
		$ce = new CatEveryone( $this->sql, $this->session );
		$fres = $ce->changeMyLostPassword( $_POST["firstpassword"], $_POST["secondpassword"] );
		$this->formFunction( $fres );
	}
	public function form_logout() {
		$ce = new CatEveryone( $this->sql, $this->session );
		$fres = $ce->logoutUser();
		$this->formFunction( $fres );
	}
	public function form_publicunban() {
		$ce = new CatEveryone( $this->sql, $this->session );
		$fres = $ce->deletePublicOldItem( $_POST["steamid"], $_POST["reason"] );
		$this->formFunction( $fres );
	}
	public function getHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->getHtmlTpl( "admin_everyone_root.tpl" );
			break;
			case "login":
			return $this->getHtmlTpl( "admin_everyone_login.tpl" );
			break;
			case "change":
			return $this->getHtmlTpl( "admin_everyone_change.tpl" );
			break;
			default:
			return $this->getHtmlTpl( "admin_everyone.tpl" );
		}
	}
	public function showHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->showHtmlTpl( "admin_everyone_root.tpl" );
			break;
			case "login":
			return $this->showHtmlTpl( "admin_everyone_login.tpl" );
			break;
			case "change":
			return $this->showHtmlTpl( "admin_everyone_change.tpl" );
			break;
			default:
			return $this->showHtmlTpl( "admin_everyone.tpl" );
		}
	}
	public function __destruct() { }
	private function clear() {
		$this->sql = NULL;
		$this->session = NULL;
		$this->ip = NULL;
		$this->sub = NULL;
	}
	private function formFunction( $fres ) {
		$fr = new AdminFormResponseUI( $this->sql );
		$fr->initialize( $fres );
		$this->assign( "everyone", $fr->getHTML() );
	}
	private $sql;
	private $session;
	private $ip;
	private $sub;
}
class AdminAcctsUI extends ObjectUI implements IObjectUI {
	public function __construct( $q, $g, $s, $sc, $i ) {
		parent::__construct();
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->sc = $sc;
		$this->ip = $i;
	}
	public function processCategory() {
		$this->sub = "root";
		if( isset( $_REQUEST["sub"] ) ) {
			if( $_REQUEST["sub"] != "root" ) { $this->sub = $_REQUEST["sub"]; }
		}
		$this->id = NULL;
		if( isset( $_REQUEST["id"] ) ) { $this->id = $_REQUEST["id"]; }
		$fr = new FormResponse( $this->sqlsite );
		if( !method_exists( $this, $this->sub ) ) {
			$this->sub = "error";
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "invalidsub", 1 ) );
			return;
		}
		if( $this->session->canAccessWebPage( "accts", $this->sub ) != 0 ) {
			$this->sub = "error";
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "access", 2 ) );
			return;
		}
		call_user_func( array( &$this, $this->sub ) );
	}
	public function root() { }
	public function addserveruser() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$groupsArr = $a->getServerUserGroups( NULL );
		$this->assign( "direction", "form_addserveruser" );
		$this->assign( "groups", $groupsArr );
		$this->assign( "servers", $this->sc->toArray() );
	}
	public function preeditserveruser() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$usersArr = $a->getServerUsers( NULL );
		$this->assign( "direction", "editserveruser" );
		$this->assign( "users", $usersArr );
	}
	public function editserveruser() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$userid = $_POST["userid"];
		$userArr = $a->getServerUsers( $userid );
		$groupsArr = $a->getServerUserGroups( NULL );
		$mygroupArr = $a->getServerUserGroupsByUser( $userid );
		$steamidsArr = $a->getServerUserSteamids( $userid );
		$servers = $this->sc->toArray();
		$steamidsstr = implode( "\r\n", $steamidsArr );
		$steamidsstr .= "\r\n";
		$this->assign( "userid", $userid );
		$this->assign( "user", $userArr[0] );
		$this->assign( "groups", $groupsArr );
		$this->assign( "steamids", $steamidsstr );
		$this->assign( "mygroups", $mygroupArr );
		$this->assign( "servers", $servers );
	}
	public function deleteserveruser() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$usersArr = $a->getServerUsers( NULL );
		$this->assign( "direction", "form_deleteserveruser" );
		$this->assign( "users", $usersArr );
	}
	public function addservergroup() { $this->assign( "direction", "form_addservergroup" ); }
	public function preeditservergroup() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$groupsArr = $a->getServerUserGroups( NULL );
		$this->assign( "direction", "editservergroup" );
		$this->assign( "groups", $groupsArr );
	}
	public function editservergroup() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$groupsArr = $a->getServerUserGroups( $_POST["groupid"] );
		$this->assign( "direction", "form_editservergroup" );
		$this->assign( "group", $groupsArr[0] );
	}
	public function deleteservergroup() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$groupsArr = $a->getServerUserGroups( NULL );
		$this->assign( "direction", "form_deleteservergroup" );
		$this->assign( "groups", $groupsArr );
	}
	public function form_addserveruser() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $a->addServerUser( $_POST["username"], $_POST["password"], $_POST["steamids"], $_POST["servgroups"], $_POST["irc"] );
		$this->formFunction( $fres );
	}
	public function form_editserveruser() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $a->editServerUser( $_POST["username"], $_REQUEST["userid"], $_POST["steamids"], $_POST["servgroup"], $_POST["irc"] );
		$this->formFunction( $fres );
	}
	public function form_deleteserveruser() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $a->deleteServerUser( $_POST["userid"] );
		$this->formFunction( $fres );
	}
	public function form_addservergroup() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $a->addServerUserGroup( $_POST["name"], $_POST["userlevel"], $_POST["weblevel"] );
		$this->formFunction( $fres );
	}
	public function form_editservergroup() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $a->editServerUserGroup( $_REQUEST["groupid"], $_POST["name"], $_POST["userlevel"], $_POST["weblevel"] );
		$this->formFunction( $fres );
	}
	public function form_deleteservergroup() {
		$a = new Accounts( $this->sqlsite, $this->sqlgame, $this->session, $this->sc );
		$fres = $a->deleteServerUserGroup( $_POST["groupid"] );
		$this->formFunction( $fres );
	}
	public function getHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->getHtmlTpl( "admin_accts_root.tpl" );
			break;
			case "addserveruser":
			return $this->getHtmlTpl( "admin_accts_useradd.tpl" );
			break;
			case "preeditserveruser":
			return $this->getHtmlTpl( "admin_accts_userpreedit.tpl" );
			break;
			case "editserveruser":
			return $this->getHtmlTpl( "admin_accts_editserver.tpl" );
			break;
			case "deleteserveruser":
			return $this->getHtmlTpl( "admin_accts_userdelete.tpl" );
			break;
			case "addservergroup":
			return $this->getHtmlTpl( "admin_accts_groupadd.tpl" );
			break;
			case "preeditservergroup":
			return $this->getHtmlTpl( "admin_accts_grouppreedit.tpl" );
			break;
			case "editservergroup":
			return $this->getHtmlTpl( "admin_accts_groupedit.tpl" );
			break;
			case "deleteservergroup":
			return $this->getHtmlTpl( "admin_accts_groupdelete.tpl" );
			break;
			default:
			return $this->getHtmlTpl( "admin_accts.tpl" );
		}
	}
	public function showHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->showHtmlTpl( "admin_accts_root.tpl" );
			break;
			case "addserveruser":
			return $this->showHtmlTpl( "admin_accts_useradd.tpl" );
			break;
			case "preeditserveruser":
			return $this->showHtmlTpl( "admin_accts_userpreedit.tpl" );
			break;
			case "editserveruser":
			return $this->showHtmlTpl( "admin_accts_editserver.tpl" );
			break;
			case "deleteserveruser":
			return $this->showHtmlTpl( "admin_accts_userdelete.tpl" );
			break;
			case "addservergroup":
			return $this->showHtmlTpl( "admin_accts_groupadd.tpl" );
			break;
			case "preeditservergroup":
			return $this->showHtmlTpl( "admin_accts_grouppreedit.tpl" );
			break;
			case "editservergroup":
			return $this->showHtmlTpl( "admin_accts_groupedit.tpl" );
			break;
			case "deleteservergroup":
			return $this->showHtmlTpl( "admin_accts_groupdelete.tpl" );
			break;
			default:
			return $this->showHtmlTpl( "admin_accts.tpl" );
		}
	}
	public function __destruct() { }
	private function clear() {
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
		$this->sc = NULL;
		$this->ip = NULL;
		$this->id = NULL;
		$this->sub = NULL;
	}
	private function formFunction( $fres ) {
		$fr = new AdminFormResponseUI( $this->sqlsite );
		$fr->initialize( $fres );
		$this->assign( "accts", $fr->getHTML() );
	}
	private $sqlsite;
	private $sqlgame;
	private $session;
	private $sc;
	private $ip;
	private $id;
	private $sub;
}
class MysqlException extends Exception {
	public function __construct($message, $code = 0) { parent::__construct($message, $code); }
	public function __toString() {
		$string = __CLASS__ . " = ";
		if( $code != 0 ) {
			$string .= "Code: {$this->code}, ";
		}
		$string .= "Msg: {$this->message}\n";
		return $string;
	}
}
class FormResponse {
	const ERROR = 1;
	const THANKYOU = 2;
	public function __construct( $s ) {
		$this->clean();
		$this->error = array(
			"authed" => "You are not authed.",
			"access" => "You do not have the access level to view this section.",
			"missing" => "You are missing a field in your form. Please go back and submit again.",
			"steamid" => "You have provided an invalid steamid.",
			"rowchange" => "There were zero rows affected by your request.",
			"norecords" => "There are no records in the set.",
			"sql" => "Mysql Exception. Please contact the web administrator.",
			"invalidcat" => "This is not a valid category.",
			"invalidsub" => "This is not a valid subcategory.",
			"login" => "Login failed. Either your username or password are not correct.",
			"passmatch" => "The passwords don't match.",
			"fileformat" => "The file format you provided is not valid.",
			"filemove" => "Unable to upload the file. Please contact the web administrator"
		);
		$this->thankyou = array(
			"addserveruser" => "You have added a server user.",
			"editserveruser" => "You have edited a server user.",
			"deleteserveruser" => "You have deleted a server user.",
			"addservergroup" => "You have added a server group.",
			"editservergroup" => "You have edited a server group.",
			"deleteservergroup" => "You have deleted a server group.",
			"ban" => "Your ban request has been added.",
			"unban" => "Your unban request has been added.",
			"gag" => "Your gag request has been added.",
			"ungag" => "Your ungag request has been added.",
			"verify" => "You have approved the required requests.",
			"login" => "You have been logged in.",
			"passwordreset" => "You password was reset! Please log in now.",
			"logout" => "You have been logged out.",
			"addcharacter" => "You have just added a new custom character.",
			"editcharacter" => "You have edited a custom character.",
			"deletecharacter" => "You have deleted a custom character.",
			"handle" => "You have handled a cheater report.",
			"addtag" => "You have added a tag to the restricted list.",
			"deletetag" => "You have deleted a tag to the restricted list.",
			"addip" => "You have added an IP from the restricted list.",
			"deleteip" => "You have deleted an IP from the restricted list.",
			"addreveal" => "You have added a reveal steamid to the list.",
			"deletereveal" => "You have deleted a reveal steamid to the list.",
			"addfilter" => "You have added a filtered word to the restricted list.",
			"deletefilter" => "You have deleted a filtered word to the restricted list.",
			"addcfg" => "You have added a server configuration.",
			"editcfg" => "You have edited a server configuration.",
			"copycfg" => "You have copied a server configuration.",
			"deletecfg" => "You have deleted a server configurations.",
			"addad" => "You have just added a new advertisement.",
			"deletead" => "You have just deleted a new advertisement.",
			"mapcycle" => "You have just changed the mapcycle on the server.",
			"upload" => "You have uploaded a map to the server.",
			"publicunban" => "You have requested an unban. An admin will make a decision about the unban shortly."
		);
	}
	public function getResponse( $type, $id, $code = -1 ) {
		if( $type != self::ERROR && $type != self::THANKYOU ) { return new FormResult( self::ERROR, "UnknownType", -1 ); }
		$myarr = NULL;
		if( $type == self::THANKYOU ) { $myarr = $this->thankyou; }
		else { $myarr = $this->error; }
		$desc = $myarr["{$id}"];
		return new FormResult( $type, $desc, $code );
	}
	public function __destruct() { }
	private function clean() {
		$this->error = NULL;
		$this->thankyou = NULL;
	}
	private $error;
	private $thankyou;
}
class Ban extends BanGagCommon {
	const UNKNOWN = 0;
	const BAN = 1;
	const GAG = 2;
	public function __construct( $q, $gq, $s, $sc ) {
		parent::__construct( $q, $gq, $s, $sc, self::BAN );
	}
}
class Session {
	public function __construct( $q ) {
		$this->clear();
		$this->access = array(
			"adminroot" => 1,
			"everyone" => 1,
			"gag" => 2,
			"ban" => 4,
			"log" => 8,
			"restrict" => 16,
			"character" => 32,
			"manager" => 64,
			"users" => 128,
			"config" => 256
		);
		$this->sql = $q;
		$this->process();
	}
	public function login( $username, $password ) {
		$myusername = $this->sql->getEscapeString( trim( $username ) );
		$mypassword = $this->sql->getEscapeString( md5( trim( $password ) ) );
		$myuserid = 0;
		$myusergroupname = "";
		$myusergroupid = "";
		$myserverlevel = 0;
		$myweblevel = 0;
		$action = "SELECT t1.id, t1.playername, t3.id, t3.groupname, t3.userlevel, t3.weblevel FROM staff AS t1, servers AS t2, usergroups AS t3 WHERE t1.playername = '{$myusername}' AND t1.password = '{$mypassword}' AND t2.staffid = t1.id AND t2.usergroupid = t3.id ORDER BY t3.weblevel DESC LIMIT 1";
		$myuserid = NULL;
		$myusername = NULL;
		$myusergroupid = NULL;
		$myusergroupname = NULL;
		$myserverlevel = NULL;
		$myweblevel = NULL;
		try {
			$res = $this->sql->query( $action );
			if( $res->getNumRows() == 0 || !$res->getNextRow() ) {
				$this->sql->cleanUpResult( $res );
				return 1;
			}
			$myuserid = $res->getValueAt( 0 );
			$myusername = $res->getValueAt( 1 );
			$myusergroupid = $res->getValueAt( 2 );
			$myusergroupname = $res->getValueAt( 3 );
			$myserverlevel = $res->getValueAt( 4 );
			$myweblevel = $res->getValueAt( 5 );
			$this->sql->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return 2; }
		$this->session = session_id();
		session_register("username");	
		session_register("user_id");
		session_register("usergroup_name");
		session_register("usergroup_id");
		session_register("serverlevel");
		session_register("weblevel");
		$_SESSION["username"] = $myusername;
		$_SESSION["user_id"] = $myuserid;
		$_SESSION["usergroup_name"] = $myusergroupname;
		$_SESSION["usergroup_id"] = $myusergroupid;
		$_SESSION["serverlevel"] = $myserverlevel;
		$_SESSION["weblevel"] = $myweblevel;
		$this->username = $myusername;
		$this->user_id = $myuserid;
		$this->usergroup_name = $myusergroupname;
		$this->usergroup_id = $usergroup_id;
		$this->serverlevel = $myserverlevel;
		$this->weblevel = $myweblevel;
		$this->authed = TRUE;
		/*
		echo( "session = " . $this->session . "<br>\n" );
		echo( "username = " . $this->username . "<br>\n" );
		echo( "user_id = " . $this->user_id . "<br>\n" );
		echo( "usergroup_name = " . $this->usergroup_name . "<br>\n" );
		echo( "usergroup_id = " . $this->usergroup_id . "<br>\n" );
		echo( "serverlevel = " . $this->serverlevel . "<br>\n" );
		echo( "weblevel = " . $this->weblevel . "<br>\n" );
		echo( "authed = " . $this->authed . "<br>\n" );
		*/
		return 0;
	}
	public function logout() {
		$this->clear();
		session_destroy();
	}
	public function canAccessWebPage( $cat, $sub ) {
		if( !isset($cat) ) { return 3; }
		if( strlen($cat) == 0 ) { return 4; }
		$myweblevel = $this->weblevel;
		$requiredLevel = isset( $this->access["{$cat}"] ) ? $this->access["{$cat}"] : 65535;
		return (($myweblevel & $requiredLevel) == $requiredLevel) ? 0 : 2;
	}
	public function getSteamIds( $uid ) {
		$myuserid = $this->sql->getEscapeString( $uid );
		$action = "SELECT t2.steamid FROM staff AS t1, steamids AS t2 WHERE t1.id = {$myuserid} AND t1.id = t2.staffid";
		$myarr = array();
		try {
			$res = $this->sql->query( $action );
			$cnt = 0;
			while( $res->getNextRow() ) {
				$myarr[$cnt] = $res->getValueAt( 0 );
				$cnt++;
			}
			$this->sql->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return NULL; }
		return $myarr;
	}
	public function getUsername() { return $this->username; }
	public function getUserGroupId() { return $this->usergroup_id; }
	public function getUserGroupName() { return $this->usergroup_name; }
	public function getUserId() { return $this->user_id; }
	public function getWebLevel() { return $this->weblevel; }
	public function getServerLevel() { return $this->serverlevel; }
	public function isAuthed() { return $this->authed; }
	public function __destruct() { }
	private function process() {
		if( session_is_registered("username") ) {
			$this->session = session_id();
			$this->username = $_SESSION["username"];
			$this->user_id = $_SESSION["user_id"];
			$this->usergroup_name = $_SESSION["usergroup_name"];
			$this->usergroup_id = $_SESSION["usergroup_id"];
			$this->serverlevel = $_SESSION["serverlevel"];
			$this->weblevel = $_SESSION["weblevel"];
			$this->authed = $this->user_id != 0;
			/*
			echo( "session = " . $this->session . "<br>\n" );
			echo( "username = " . $this->username . "<br>\n" );
			echo( "user_id = " . $this->user_id . "<br>\n" );
			echo( "usergroup_name = " . $this->usergroup_name . "<br>\n" );
			echo( "usergroup_id = " . $this->usergroup_id . "<br>\n" );
			echo( "serverlevel = " . $this->serverlevel . "<br>\n" );
			echo( "weblevel = " . $this->weblevel . "<br>\n" );
			echo( "authed = " . $this->authed . "<br>\n" );
			*/
		}
		else {
			$this->session = session_id();
			session_register("username");	
			session_register("user_id");
			session_register("usergroup_name");
			session_register("usergroup_id");
			session_register("serverlevel");
			session_register("weblevel");
			$_SESSION["username"] = "Guest";
			$_SESSION["user_id"] = 0;
			$_SESSION["usergroup_name"] = "GeneralAccess";
			$_SESSION["usergroup_id"] = 1;
			$_SESSION["serverlevel"] = 0;
			$_SESSION["weblevel"] = 1;
			$this->username = "Guest";
			$this->user_id = 0;
			$this->usergroup_name = "GeneralAccess";
			$this->usergroup_id = 1;
			$this->serverlevel = 0;
			$this->weblevel = 1;
			$this->authed = FALSE;
		}
	}
	private function clear() {
		$this->session = "";
		$this->username = "";
		$this->user_id = 0;
		$this->usergroup_name = "";
		$this->usergroup_id = 0;
		$this->serverlevel = 0;
		$this->weblevel = 0;
		$this->authed = FALSE;
	}
	private $session;
	private $username;
	private $user_id;
	private $usergroup_name;
	private $usergroup_id;
	private $serverlevel;
	private $weblevel;
	private $authed;
	private $access;
	private $sql;
}
class AdminRestrictUI extends ObjectUI implements IObjectUI {
	public function __construct( $q, $g, $s, $i ) {
		parent::__construct();
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
		$this->ip = $i;
	}
	public function processCategory() {
		$this->sub = "root";
		if( isset( $_REQUEST["sub"] ) ) {
			if( $_REQUEST["sub"] != "root" ) { $this->sub = $_REQUEST["sub"]; }
		}
		$this->id = NULL;
		if( isset( $_REQUEST["id"] ) ) { $this->id = $_REQUEST["id"]; }
		$fr = new FormResponse( $this->sqlsite );
		if( !method_exists( $this, $this->sub ) ) {
			$this->sub = "error";
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "invalidsub", 1 ) );
			return;
		}
		if( $this->session->canAccessWebPage( "restrict", $this->sub ) != 0 ) {
			$this->sub = "error";
			$this->formFunction( $fr->getResponse( FormResponse::ERROR, "access", 2 ) );
			return;
		}
		call_user_func( array( &$this, $this->sub ) );
	}
	public function root() { }
	public function addtag() { }
	public function deletetag() {
		$offset = $this->id - ($this->id % 50);
		$r = new Restrict( $this->sqlsite, $this->sqlgame, $this->session );
		$tagArr = $r->getTags( $offset, 50 );
		$total = $r->getTagsTotal();
		$this->assign( "total", $total );
		$this->assign( "offset", $offset );
		$this->assign( "prevoffset", $offset - 50 );
		$this->assign( "nextoffset", $offset + 50 );
		$this->assign( "count", count($tagArr) );
		$this->assign( "tags", $tagArr );
	}
	public function addip() { }
	public function deleteip() {
		$offset = $this->id - ($this->id % 50);
		$r = new Restrict( $this->sqlsite, $this->sqlgame, $this->session );
		$ipArr = $r->getIps( $offset, 50 );
		$total = $r->getIpsTotal();
		$this->assign( "total", $total );
		$this->assign( "offset", $offset );
		$this->assign( "prevoffset", $offset - 50 );
		$this->assign( "nextoffset", $offset + 50 );
		$this->assign( "count", count($ipArr) );
		$this->assign( "ips", $ipArr );
	}
	public function addreveal() { }
	public function deletereveal() {
		$offset = $this->id - ($this->id % 50);
		$r = new Restrict( $this->sqlsite, $this->sqlgame, $this->session );
		$revealArr = $r->getReveal( $offset, 50 );
		$total = $r->getRevealTotal();
		$this->assign( "total", $total );
		$this->assign( "offset", $offset );
		$this->assign( "prevoffset", $offset - 50 );
		$this->assign( "nextoffset", $offset + 50 );
		$this->assign( "count", count($revealArr) );
		$this->assign( "reveal", $revealArr );
	}
	public function addfilter() { }
	public function deletefilter() {
		$offset = $this->id - ($this->id % 50);
		$r = new Restrict( $this->sqlsite, $this->sqlgame, $this->session );
		$filterArr = $r->getFilter( $offset, 50 );
		$total = $r->getFilterTotal();
		$this->assign( "total", $total );
		$this->assign( "offset", $offset );
		$this->assign( "prevoffset", $offset - 50 );
		$this->assign( "nextoffset", $offset + 50 );
		$this->assign( "count", count($filterArr) );
		$this->assign( "filter", $filterArr );
	}
	public function form_addtag() {
		$r = new Restrict( $this->sqlsite, $this->sqlgame, $this->session );
		$fres = $r->addTag( $_POST["tag"], $_POST["reason"] );
		$this->formFunction( $fres );
	}
	public function form_deletetag() {
		$r = new Restrict( $this->sqlsite, $this->sqlgame, $this->session );
		$fres = $r->delTag( $this->id );
		$this->formFunction( $fres );
	}
	public function form_addip() {
		$r = new Restrict( $this->sqlsite, $this->sqlgame, $this->session );
		$fres = $r->addIp( $_POST["ip"], $_POST["name"], $_POST["reason"] );
		$this->formFunction( $fres );
	}
	public function form_deleteip() {
		$r = new Restrict( $this->sqlsite, $this->sqlgame, $this->session );
		$fres = $r->deleteIp( $this->id );
		$this->formFunction( $fres );
	}
	public function form_addreveal() {
		$r = new Restrict( $this->sqlsite, $this->sqlgame, $this->session );
		$fres = $r->addReveal( $_POST["steamid"], $_POST["name"] );
		$this->formFunction( $fres );
	}
	public function form_deletereveal() {
		$r = new Restrict( $this->sqlsite, $this->sqlgame, $this->session );
		$fres = $r->delReveal( $this->id );
		$this->formFunction( $fres );
	}
	public function form_addfilter() {
		$r = new Restrict( $this->sqlsite, $this->sqlgame, $this->session );
		$fres = $r->addFilter( $_POST["filter"], $_POST["replace"] );
		$this->formFunction( $fres );
	}
	public function form_deletefilter() {
		$r = new Restrict( $this->sqlsite, $this->sqlgame, $this->session );
		$fres = $r->deleteFilter( $this->id );
		$this->formFunction( $fres );
	}
	public function getHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->getHtmlTpl( "admin_restrict_root.tpl" );
			break;
			case "addtag":
			return $this->getHtmlTpl( "admin_restrict_addtag.tpl" );
			break;
			case "deletetag":
			return $this->getHtmlTpl( "admin_restrict_deletetag.tpl" );
			break;
			case "addip":
			return $this->getHtmlTpl( "admin_restrict_addip.tpl" );
			break;
			case "deleteip":
			return $this->getHtmlTpl( "admin_restrict_deleteip.tpl" );
			break;
			case "addreveal":
			return $this->getHtmlTpl( "admin_restrict_addreveal.tpl" );
			break;
			case "deletereveal":
			return $this->getHtmlTpl( "admin_restrict_deletereveal.tpl" );
			break;
			case "addfilter":
			return $this->getHtmlTpl( "admin_restrict_addfilter.tpl" );
			break;
			case "deletefilter":
			return $this->getHtmlTpl( "admin_restrict_deletefilter.tpl" );
			break;
			default:
			return $this->getHtmlTpl( "admin_restrict.tpl" );
		}
	}
	public function showHTML() {
		switch( $this->sub ) {
			case "root":
			return $this->showHtmlTpl( "admin_restrict_root.tpl" );
			break;
			case "addtag":
			return $this->showHtmlTpl( "admin_restrict_addtag.tpl" );
			break;
			case "deletetag":
			return $this->showHtmlTpl( "admin_restrict_deletetag.tpl" );
			break;
			case "addip":
			return $this->showHtmlTpl( "admin_restrict_addip.tpl" );
			break;
			case "deleteip":
			return $this->showHtmlTpl( "admin_restrict_deleteip.tpl" );
			break;
			case "addreveal":
			return $this->showHtmlTpl( "admin_restrict_addreveal.tpl" );
			break;
			case "deletereveal":
			return $this->showHtmlTpl( "admin_restrict_deletereveal.tpl" );
			break;
			case "addfilter":
			return $this->showHtmlTpl( "admin_restrict_addfilter.tpl" );
			break;
			case "deletefilter":
			return $this->showHtmlTpl( "admin_restrict_deletefilter.tpl" );
			break;
			default:
			return $this->showHtmlTpl( "admin_restrict.tpl" );
		}
	}
	public function __destruct() { }
	private function clear() {
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
		$this->ip = NULL;
		$this->id = NULL;
		$this->sub = NULL;
	}
	private function formFunction( $fres ) {
		$fr = new AdminFormResponseUI( $this->sqlsite );
		$fr->initialize( $fres );
		$this->assign( "restrict", $fr->getHTML() );
	}
	private $sqlsite;
	private $sqlgame;
	private $session;
	private $ip;
	private $id;
	private $sub;
}
class AdminGagUI extends AdminBanGagCommonUI {
	const UNKNOWN = 0;
	const BAN = 1;
	const GAG = 2;
	public function __construct( $q, $g, $s, $sc, $i ) {
		parent::__construct( $q, $g, $s, $sc, $i, self::GAG );
	}
	public function __destruct() { }
}
class Restrict {
	public function __construct( $q, $g, $s ) {
		$this->clear();
		$this->sqlsite = $q;
		$this->sqlgame = $g;
		$this->session = $s;
	}
	public function getTagsTotal() {
		if( !$this->session->isAuthed() ) { return -1; }
		if( $this->session->canAccessWebPage( "restrict", "addtag" ) != 0 ) { return -1; }
		$selectTag = "SELECT COUNT(id) FROM restrictedtag";
		$cnt = $this->sqlgame->count($selectTag);
		return $cnt;
	}
	public function getTags( $offset, $limit ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( "restrict", "addtag" ) != 0 ) { return NULL; }
		$offset = isset( $offset ) ? trim( htmlspecialchars( $offset ) ) : NULL;
		$limit = isset( $limit ) ? trim( htmlspecialchars( $limit ) ) : NULL;
		if( is_null($offset) || is_null($limit) ) { return NULL; }
		$offset = $this->sqlgame->getEscapeString($offset);
		$limit = $this->sqlgame->getEscapeString($limit);
		$selectTag = "SELECT id, regexp_tag, reason FROM restrictedtag LIMIT {$offset}, {$limit}";
		$myarray = array();
		try {
			$res = $this->sqlgame->query($selectTag);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$reTag = $res->getValueAt( 1 );
				$reason = $res->getValueAt( 2 );
				$item = array();
				$item["id"] = $id;
				$item["regexp"] = $reTag;
				$item["reason"] = $reason;
				$myarray[$cnt] = $item;
				$cnt++;
			}
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return NULL; }
		return $myarray;
	}
	public function addTag( $regexpTag, $reason ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "restrict", "addtag" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$regexpTag = isset( $regexpTag ) ? trim( htmlspecialchars( $regexpTag ) ) : NULL;
		$reason = isset( $reason ) ? trim( htmlspecialchars( $reason ) ) : NULL;
		if( is_null($regexpTag) || is_null($reason) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$regexpTag = $this->sqlgame->getEscapeString($regexpTag);
		$reason = $this->sqlgame->getEscapeString($reason);
		$addTagAction = "INSERT INTO restrictedtag (id, regexp_tag, reason) VALUES ( NULL, '{$regexpTag}', '{$reason}' )";
		try {
			$res = $this->sqlgame->query($addTagAction);
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "addtag", 0 );
	}
	public function delTag( $id ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "restrict", "deletetag" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		if( is_null($id) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$id = $this->sqlgame->getEscapeString($id);
		$deleteTag = "DELETE FROM restrictedtag WHERE id = {$id}";
		try {
			$res = $this->sqlgame->query($deleteTag);
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "deletetag", 0 );
	}
	public function getIpsTotal() {
		if( !$this->session->isAuthed() ) { return -1; }
		if( $this->session->canAccessWebPage( "restrict", "addip" ) != 0 ) { return -1; }
		$selectIp = "SELECT COUNT(id) FROM restrictedip";
		$cnt = $this->sqlgame->count($selectIp);
		return $cnt;
	}
	public function getIps( $offset, $limit ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( "restrict", "addip" ) != 0 ) { return NULL; }
		$offset = isset( $offset ) ? trim( htmlspecialchars( $offset ) ) : NULL;
		$limit = isset( $limit ) ? trim( htmlspecialchars( $limit ) ) : NULL;
		if( is_null($offset) || is_null($limit) ) { return NULL; }
		$offset = $this->sqlgame->getEscapeString($offset);
		$limit = $this->sqlgame->getEscapeString($limit);
		$selectIp = "SELECT id, regexp_ip, playername, reason FROM restrictedip LIMIT {$offset}, {$limit}";
		$myarray = array();
		try {
			$res = $this->sqlgame->query($selectIp);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$reIp = $res->getValueAt( 1 );
				$pName = $res->getValueAt( 2 );
				$reason = $res->getValueAt( 3 );
				$item = array();
				$item["id"] = $id;
				$item["regexp"] = $reIp;
				$item["name"] = $pName;
				$item["reason"] = $reason;
				$myarray[$cnt] = $item;
				$cnt++;
			}
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return NULL; }
		return $myarray;
	}
	public function addIp( $regexpIp, $name, $reason ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "restrict", "addip" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$regexpIp = isset( $regexpIp ) ? trim( htmlspecialchars( $regexpIp ) ) : NULL;
		$name = isset( $name ) ? trim( htmlspecialchars( $name ) ) : NULL;
		$reason = isset( $reason ) ? trim( htmlspecialchars( $reason ) ) : NULL;
		if( is_null($regexpIp) || is_null($name) || is_null($reason) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$regexpIp = $this->sqlgame->getEscapeString($regexpIp);
		$name = $this->sqlgame->getEscapeString($name);
		$reason = $this->sqlgame->getEscapeString($reason);
		$insertIp = "INSERT INTO restrictedip (id, regexp_ip, playername, reason) VALUES ( NULL, '{$regexpIp}', '{$name}', '{$reason}' )";
		try {
			$res = $this->sqlgame->query($insertIp);
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "addip", 0 );
	}
	public function deleteIp( $id ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "restrict", "deleteip" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		if( is_null($id) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$id = $this->sqlgame->getEscapeString($id);
		$deleteIp = "DELETE FROM restrictedip WHERE id = {$id}";
		try {
			$res = $this->sqlgame->query($deleteIp);
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "deleteip", 0 );
	}
	public function getRevealTotal() {
		if( !$this->session->isAuthed() ) { return -1; }
		if( $this->session->canAccessWebPage( "restrict", "addreveal" ) != 0 ) { return -1; }
		$selectReveal = "SELECT COUNT(id) FROM reveal";
		$cnt = $this->sqlgame->count($selectReveal);
		return $cnt;
	}
	public function getReveal( $offset, $limit ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( "restrict", "addreveal" ) != 0 ) { return NULL; }
		$offset = isset( $offset ) ? trim( htmlspecialchars( $offset ) ) : NULL;
		$limit = isset( $limit ) ? trim( htmlspecialchars( $limit ) ) : NULL;
		if( is_null($offset) || is_null($limit) ) { return NULL; }
		$offset = $this->sqlgame->getEscapeString($offset);
		$limit = $this->sqlgame->getEscapeString($limit);
		$selectReveal = "SELECT id, steamid, playername FROM reveal LIMIT {$offset}, {$limit}";
		$myarray = array();
		try {
			$res = $this->sqlgame->query($selectReveal);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$steamid = $res->getValueAt( 1 );
				$name = $res->getValueAt( 2 );
				$item = array();
				$item["id"] = $id;
				$item["steamid"] = $steamid;
				$item["name"] = $name;
				$myarray[$cnt] = $item;
				$cnt++;
			}
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return NULL; }
		return $myarray;
	}
	public function addReveal( $steamid, $name ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "restrict", "addreveal" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$steamid = isset( $steamid ) ? trim( htmlspecialchars( $steamid ) ) : NULL;
		$name = isset( $name ) ? trim( htmlspecialchars( $name ) ) : NULL;
		if( is_null($steamid) || is_null($name) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		else if( preg_match( "/^(STEAM_0:)[01]{1}[:]{1}[0-9]+$/", $steamid ) == 0 ) { return $fr->getResponse( FormResponse::ERROR, "steamid", 2 ); }
		$steamid = $this->sqlgame->getEscapeString($steamid);
		$name = $this->sqlgame->getEscapeString($name);
		$addReveal = "INSERT INTO reveal (id, steamid, playername) VALUES ( NULL, '{$steamid}', '{$name}' )";
		try {
			$res = $this->sqlgame->query($addReveal);
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "addreveal", 0 );
	}
	public function delReveal( $id ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "restrict", "deletereveal" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		if( is_null($id) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$id = $this->sqlgame->getEscapeString($id);
		$deleteReveal = "DELETE FROM reveal WHERE id = {$id}";
		try {
			$res = $this->sqlgame->query($deleteReveal);
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "deletereveal", 0 );
	}
	public function getFilterTotal() {
		if( !$this->session->isAuthed() ) { return -1; }
		if( $this->session->canAccessWebPage( "restrict", "addfilter" ) != 0 ) { return -1; }
		$selectFilter = "SELECT COUNT(id) FROM filterreplace";
		$cnt = $this->sqlgame->count($selectFilter);
		return $cnt;
	}
	public function getFilter( $offset, $limit ) {
		if( !$this->session->isAuthed() ) { return NULL; }
		if( $this->session->canAccessWebPage( "restrict", "addfilter" ) != 0 ) { return NULL; }
		$offset = isset( $offset ) ? trim( htmlspecialchars( $offset ) ) : NULL;
		$limit = isset( $limit ) ? trim( htmlspecialchars( $limit ) ) : NULL;
		if( is_null($offset) || is_null($limit) ) { return NULL; }
		$offset = $this->sqlgame->getEscapeString($offset);
		$limit = $this->sqlgame->getEscapeString($limit);
		$selectFilter = "SELECT id, regexp_filter, text_replace FROM filterreplace LIMIT {$offset}, {$limit}";
		$myarray = array();
		try {
			$res = $this->sqlgame->query($selectFilter);
			$cnt = 0;
			while( $res->getNextRow() ) {
				$id = $res->getValueAt( 0 );
				$filter = $res->getValueAt( 1 );
				$replace = $res->getValueAt( 2 );
				$item = array();
				$item["id"] = $id;
				$item["filter"] = $filter;
				$item["replace"] = $replace;
				$myarray[$cnt] = $item;
				$cnt++;
			}
			$this->sqlgame->cleanUpResult( $res );
		}
		catch( MysqlException $e ) { return NULL; }
		return $myarray;
	}
	public function addFilter( $filter, $replace ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "restrict", "addfilter" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$filter = isset( $filter ) ? trim( htmlspecialchars( $filter ) ) : NULL;
		$replace = isset( $replace ) ? trim( htmlspecialchars( $replace ) ) : NULL;
		if( is_null($filter) || is_null($replace) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$filter = $this->sqlgame->getEscapeString($filter);
		$replace = $this->sqlgame->getEscapeString($replace);
		$addFilter = "INSERT INTO filterreplace (id, regexp_filter, text_replace) VALUES ( NULL, '{$filter}', '{$replace}' )";
		try {
			$res = $this->sqlgame->query($addFilter);
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "addfilter", 0 );
	}
	public function deleteFilter( $id ) {
		$fr = new FormResponse( $this->sqlsite );
		if( !$this->session->isAuthed() ) { return $fr->getResponse( FormResponse::ERROR, "authed", 1 ); }
		if( $this->session->canAccessWebPage( "restrict", "deletefilter" ) != 0 ) { return $fr->getResponse( FormResponse::ERROR, "access", 1 ); }
		$id = isset( $id ) ? trim( htmlspecialchars( $id ) ) : NULL;
		if( is_null($id) ) { return $fr->getResponse( FormResponse::ERROR, "missing", 2 ); }
		$id = $this->sqlgame->getEscapeString($id);
		$deleteFilter = "DELETE FROM filterreplace WHERE id = {$id}";
		try {
			$res = $this->sqlgame->query($deleteFilter);
			$affrows = $this->sqlgame->getAffectedRows();
			$this->sqlgame->cleanUpResult( $res );
			if( $affrows == 0 ) { return $fr->getResponse( FormResponse::ERROR, "rowchange", 3 ); }
		}
		catch( MysqlException $e ) { return $fr->getResponse( FormResponse::ERROR, "sql", $e->getCode() ); }
		return $fr->getResponse( FormResponse::THANKYOU, "deletefilter", 0 );
	}
	public function __destruct() { }
	private function clear() {
		$this->sqlsite = NULL;
		$this->sqlgame = NULL;
		$this->session = NULL;
	}
	private $sqlsite;
	private $sqlgame;
	private $session;
}


$ip = $_SERVER["REMOTE_ADDR"];
$sess = new Session( $sqlgame );
$ca = new AdminCy6UI( $sqlgame, $sqlgame, $sess, $sc, $ip );
$ca->showHTML();
$sqlgame->close();
?>
